/// <reference types="node" />
export declare abstract class CryptoClient {
    abstract signMessage(message: string, keypair: {
        publicKey?: string;
        privateKey: Buffer;
    }): Promise<string>;
    abstract verifyMessage(message: string, signature: string, publicKey: string): Promise<boolean>;
    recoverPublicKeyFromSignature(): Promise<void>;
}
