import { ProtocolBlockExplorer } from '../../utils/ProtocolBlockExplorer';
import { NetworkType, ProtocolNetwork } from '../../utils/ProtocolNetwork';
import { ProtocolOptions } from '../../utils/ProtocolOptions';
export declare class BitcoinProtocolNetworkExtras {
    readonly indexerApi: string;
    readonly network: any;
    constructor(indexerApi?: string, network?: any);
}
export declare class BlockcypherBlockExplorer implements ProtocolBlockExplorer {
    readonly blockExplorer: string;
    constructor(blockExplorer?: string);
    getAddressLink(address: string): Promise<string>;
    getTransactionLink(transactionId: string): Promise<string>;
}
export declare class BitcoinProtocolNetwork extends ProtocolNetwork<BitcoinProtocolNetworkExtras> {
    constructor(name?: string, type?: NetworkType, rpcUrl?: string, blockExplorer?: ProtocolBlockExplorer, extras?: BitcoinProtocolNetworkExtras);
}
export declare class BitcoinProtocolConfig {
    readonly bitcoinJSLib: any;
    constructor(bitcoinJSLib?: any);
}
export declare class BitcoinProtocolOptions implements ProtocolOptions<BitcoinProtocolConfig> {
    readonly network: BitcoinProtocolNetwork;
    readonly config: BitcoinProtocolConfig;
    constructor(network?: BitcoinProtocolNetwork, config?: BitcoinProtocolConfig);
}
