"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CosmosCoin = /** @class */ (function () {
    function CosmosCoin(denom, amount) {
        this.denom = denom;
        this.amount = amount;
    }
    CosmosCoin.prototype.toJSON = function () {
        return {
            amount: this.amount,
            denom: this.denom
        };
    };
    CosmosCoin.fromJSON = function (json) {
        if (!CosmosCoin.supportedDenominations.includes(json.denom)) {
            throw new Error('Unsupported cosmos denomination');
        }
        return new CosmosCoin(json.denom, json.amount);
    };
    CosmosCoin.prototype.toRPCBody = function () {
        return {
            amount: this.amount,
            denom: this.denom
        };
    };
    CosmosCoin.fromRPCBody = function (json) {
        return new CosmosCoin(json.denom, json.amount);
    };
    CosmosCoin.supportedDenominations = ['uatom'];
    return CosmosCoin;
}());
exports.CosmosCoin = CosmosCoin;
//# sourceMappingURL=CosmosCoin.js.map