import { ProtocolBlockExplorer } from '../../utils/ProtocolBlockExplorer';
import { NetworkType, ProtocolNetwork } from '../../utils/ProtocolNetwork';
import { ProtocolOptions } from '../../utils/ProtocolOptions';
import { CosmosInfoClient } from './CosmosInfoClient';
import { CosmosNodeClient } from './CosmosNodeClient';
export declare class MintscanBlockExplorer implements ProtocolBlockExplorer {
    readonly blockExplorer: string;
    constructor(blockExplorer?: string);
    getAddressLink(address: string): Promise<string>;
    getTransactionLink(transactionId: string): Promise<string>;
}
export declare class CosmosProtocolNetwork extends ProtocolNetwork<undefined> {
    constructor(name?: string, type?: NetworkType, rpcUrl?: string, blockExplorer?: ProtocolBlockExplorer, extras?: undefined);
}
export declare class CosmosProtocolConfig {
    readonly infoClient: CosmosInfoClient;
    readonly nodeClient: CosmosNodeClient;
    constructor(infoClient?: CosmosInfoClient, nodeClient?: CosmosNodeClient);
}
export declare class CosmosProtocolOptions implements ProtocolOptions<CosmosProtocolConfig> {
    readonly network: CosmosProtocolNetwork;
    readonly config: CosmosProtocolConfig;
    constructor(network?: CosmosProtocolNetwork, config?: CosmosProtocolConfig);
}
