"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TransactionListQuery = /** @class */ (function () {
    function TransactionListQuery(offset, limit, address) {
        this.offset = offset;
        this.limit = limit;
        this.address = address;
    }
    TransactionListQuery.prototype.toJSONBody = function () {
        return JSON.stringify({
            from: this.offset,
            size: this.limit,
            query: {
                bool: {
                    must: [
                        {
                            bool: {
                                should: [
                                    {
                                        multi_match: {
                                            query: this.address,
                                            fields: ['tx.value.msg.value.from_address', 'tx.value.msg.value.to_address']
                                        }
                                    }
                                ]
                            }
                        },
                        {
                            match_phrase: {
                                'tx.value.msg.type': 'cosmos-sdk/MsgSend'
                            }
                        }
                    ]
                }
            },
            sort: [
                {
                    height: {
                        order: 'desc'
                    }
                }
            ]
        });
    };
    return TransactionListQuery;
}());
exports.TransactionListQuery = TransactionListQuery;
//# sourceMappingURL=CosmosTransactionListQuery.js.map