import { IAirGapTransaction } from '../../../interfaces/IAirGapTransaction';
import { CosmosCoin } from '../CosmosCoin';
import { CosmosProtocol } from '../CosmosProtocol';
import { CosmosMessage, CosmosMessageJSON, CosmosMessageType } from './CosmosMessage';
export declare class CosmosDelegateMessage implements CosmosMessage {
    readonly delegatorAddress: string;
    readonly validatorAddress: string;
    readonly amount: CosmosCoin;
    readonly type: CosmosMessageType;
    constructor(delegatorAddress: string, validatorAddress: string, amount: CosmosCoin, undelegate?: boolean);
    toJSON(): CosmosMessageJSON;
    static fromJSON(json: CosmosMessageJSON): CosmosDelegateMessage;
    toRPCBody(): any;
    toAirGapTransaction(protocol: CosmosProtocol, fee: string): IAirGapTransaction;
    static fromRPCBody(json: any): CosmosDelegateMessage;
}
