"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CosmosMessageTypeIndex;
(function (CosmosMessageTypeIndex) {
    CosmosMessageTypeIndex[CosmosMessageTypeIndex["SEND"] = 0] = "SEND";
    CosmosMessageTypeIndex[CosmosMessageTypeIndex["DELEGATE"] = 1] = "DELEGATE";
    CosmosMessageTypeIndex[CosmosMessageTypeIndex["UNDELEGATE"] = 2] = "UNDELEGATE";
    CosmosMessageTypeIndex[CosmosMessageTypeIndex["WITHDRAW_DELEGATION_REWARD"] = 3] = "WITHDRAW_DELEGATION_REWARD";
})(CosmosMessageTypeIndex = exports.CosmosMessageTypeIndex || (exports.CosmosMessageTypeIndex = {}));
var CosmosMessageType = /** @class */ (function () {
    function CosmosMessageType(index) {
        this.index = index;
        switch (index) {
            case CosmosMessageTypeIndex.SEND:
                this.value = 'cosmos-sdk/MsgSend';
                break;
            case CosmosMessageTypeIndex.DELEGATE:
                this.value = 'cosmos-sdk/MsgDelegate';
                break;
            case CosmosMessageTypeIndex.UNDELEGATE:
                this.value = 'cosmos-sdk/MsgUndelegate';
                break;
            case CosmosMessageTypeIndex.WITHDRAW_DELEGATION_REWARD:
                this.value = 'cosmos-sdk/MsgWithdrawDelegationReward';
                break;
            default:
                throw new Error('Unknown message type');
        }
    }
    CosmosMessageType.Send = new CosmosMessageType(CosmosMessageTypeIndex.SEND);
    CosmosMessageType.Delegate = new CosmosMessageType(CosmosMessageTypeIndex.DELEGATE);
    CosmosMessageType.Undelegate = new CosmosMessageType(CosmosMessageTypeIndex.UNDELEGATE);
    CosmosMessageType.WithdrawDelegationReward = new CosmosMessageType(CosmosMessageTypeIndex.WITHDRAW_DELEGATION_REWARD);
    return CosmosMessageType;
}());
exports.CosmosMessageType = CosmosMessageType;
//# sourceMappingURL=CosmosMessage.js.map