import { IAirGapTransaction } from '../../../interfaces/IAirGapTransaction';
import { CosmosCoin } from '../CosmosCoin';
import { CosmosProtocol } from '../CosmosProtocol';
import { CosmosMessage, CosmosMessageJSON, CosmosMessageType } from './CosmosMessage';
export declare class CosmosSendMessage implements CosmosMessage {
    readonly fromAddress: string;
    readonly toAddress: string;
    readonly amount: CosmosCoin[];
    readonly type: CosmosMessageType;
    constructor(fromAddress: string, toAddress: string, amount: CosmosCoin[]);
    toJSON(): CosmosMessageJSON;
    static fromJSON(json: CosmosMessageJSON): CosmosSendMessage;
    toRPCBody(): any;
    toAirGapTransaction(protocol: CosmosProtocol, fee: string): IAirGapTransaction;
    static fromRPCBody(json: any): CosmosSendMessage;
}
