import { IAirGapTransaction } from '../../../interfaces/IAirGapTransaction';
import { CosmosProtocol } from '../CosmosProtocol';
import { CosmosMessage, CosmosMessageJSON, CosmosMessageType } from './CosmosMessage';
export declare class CosmosWithdrawDelegationRewardMessage implements CosmosMessage {
    readonly delegatorAddress: string;
    readonly validatorAddress: string;
    readonly type: CosmosMessageType;
    constructor(delegatorAddress: string, validatorAddress: string);
    toAirGapTransaction(protocol: CosmosProtocol, fee: string): IAirGapTransaction;
    toJSON(): CosmosMessageJSON;
    static fromJSON(json: CosmosMessageJSON): CosmosWithdrawDelegationRewardMessage;
    toRPCBody(): {
        type: string;
        value: {
            delegator_address: string;
            validator_address: string;
        };
    };
    static fromRPCBody(json: any): CosmosWithdrawDelegationRewardMessage;
}
