/// <reference types="node" />
import { CryptoClient } from '../CryptoClient';
import { BaseEthereumProtocol } from './BaseEthereumProtocol';
import { EthereumInfoClient } from './clients/info-clients/InfoClient';
import { EthereumNodeClient } from './clients/node-clients/NodeClient';
export declare class EthereumCryptoClient extends CryptoClient {
    private readonly protocol;
    constructor(protocol: BaseEthereumProtocol<EthereumNodeClient, EthereumInfoClient>);
    signMessage(message: string, keypair: {
        privateKey: Buffer;
    }): Promise<string>;
    verifyMessage(message: string, signature: string, publicKey: string): Promise<boolean>;
}
