/// <reference types="node" />
import { ProtocolSymbols } from '../../utils/ProtocolSymbols';
import { BitcoinProtocol } from '../bitcoin/BitcoinProtocol';
import { CurrencyUnit, FeeDefaults } from '../ICoinProtocol';
import { GroestlcoinProtocolOptions } from './GroestlcoinProtocolOptions';
export declare class GroestlcoinProtocol extends BitcoinProtocol {
    readonly options: GroestlcoinProtocolOptions;
    symbol: string;
    name: string;
    marketSymbol: string;
    feeSymbol: string;
    feeDefaults: FeeDefaults;
    decimals: number;
    feeDecimals: number;
    identifier: ProtocolSymbols;
    units: CurrencyUnit[];
    supportsHD: boolean;
    standardDerivationPath: string;
    addressValidationPattern: string;
    addressPlaceholder: string;
    constructor(options?: GroestlcoinProtocolOptions);
    signMessage(message: string, keypair: {
        privateKey: Buffer;
    }): Promise<string>;
    verifyMessage(message: string, signature: string, publicKey: string): Promise<boolean>;
}
