"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var groestlcoinJSMessage = require("../../dependencies/src/groestlcoinjs-message-2.1.0/index");
var ProtocolSymbols_1 = require("../../utils/ProtocolSymbols");
var BitcoinProtocol_1 = require("../bitcoin/BitcoinProtocol");
var BitcoinCryptoClient_1 = require("../bitcoin/BitcoinCryptoClient");
var GroestlcoinProtocolOptions_1 = require("./GroestlcoinProtocolOptions");
var GroestlcoinProtocol = /** @class */ (function (_super) {
    __extends(GroestlcoinProtocol, _super);
    function GroestlcoinProtocol(options) {
        if (options === void 0) { options = new GroestlcoinProtocolOptions_1.GroestlcoinProtocolOptions(); }
        var _this = _super.call(this, options) || this;
        _this.options = options;
        _this.symbol = 'GRS';
        _this.name = 'Groestlcoin';
        _this.marketSymbol = 'grs';
        _this.feeSymbol = 'grs';
        _this.feeDefaults = {
            low: '0.00002',
            medium: '0.00004',
            high: '0.00005'
        };
        _this.decimals = 8;
        _this.feeDecimals = 8;
        _this.identifier = ProtocolSymbols_1.MainProtocolSymbols.GRS;
        _this.units = [
            {
                unitSymbol: 'GRS',
                factor: '1'
            },
            {
                unitSymbol: 'mGRS',
                factor: '0.0001'
            },
            {
                unitSymbol: 'Satoshi',
                factor: '0.00000001'
            }
        ];
        _this.supportsHD = true;
        _this.standardDerivationPath = "m/44'/17'/0'";
        _this.addressValidationPattern = '^([F3][a-km-zA-HJ-NP-Z1-9]{33}|grs1[a-zA-HJ-NP-Z0-9]{39})$';
        _this.addressPlaceholder = 'Fdb...';
        return _this;
    }
    GroestlcoinProtocol.prototype.signMessage = function (message, keypair) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new BitcoinCryptoClient_1.BitcoinCryptoClient(this, groestlcoinJSMessage).signMessage(message, keypair)];
            });
        });
    };
    GroestlcoinProtocol.prototype.verifyMessage = function (message, signature, publicKey) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new BitcoinCryptoClient_1.BitcoinCryptoClient(this, groestlcoinJSMessage).verifyMessage(message, signature, publicKey)];
            });
        });
    };
    return GroestlcoinProtocol;
}(BitcoinProtocol_1.BitcoinProtocol));
exports.GroestlcoinProtocol = GroestlcoinProtocol;
//# sourceMappingURL=GroestlcoinProtocol.js.map