"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("@polkadot/util");
var wasm_crypto_1 = require("@polkadot/wasm-crypto");
var CryptoClient_1 = require("../CryptoClient");
var SubstrateCryptoClient = /** @class */ (function (_super) {
    __extends(SubstrateCryptoClient, _super);
    function SubstrateCryptoClient() {
        return _super.call(this) || this;
    }
    SubstrateCryptoClient.prototype.signMessage = function (message, keypair) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var publicKeyBuffer, messageU8a;
            return __generator(this, function (_c) {
                publicKeyBuffer = Buffer.from(keypair.publicKey, 'hex');
                util_1.assert(((_a = publicKeyBuffer) === null || _a === void 0 ? void 0 : _a.length) === 32, 'Expected a valid publicKey, 32-bytes');
                util_1.assert(((_b = keypair.privateKey) === null || _b === void 0 ? void 0 : _b.length) === 64, 'Expected a valid secretKey, 64-bytes');
                messageU8a = util_1.u8aToU8a(message);
                return [2 /*return*/, "0x" + Buffer.from(wasm_crypto_1.sr25519Sign(publicKeyBuffer, keypair.privateKey, messageU8a)).toString('hex')];
            });
        });
    };
    SubstrateCryptoClient.prototype.verifyMessage = function (message, signature, publicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var messageU8a, publicKeyU8a, signatureU8a;
            return __generator(this, function (_a) {
                messageU8a = util_1.u8aToU8a(message);
                publicKeyU8a = util_1.u8aToU8a(Buffer.from(publicKey, 'hex'));
                signatureU8a = util_1.u8aToU8a(signature);
                return [2 /*return*/, wasm_crypto_1.sr25519Verify(signatureU8a, messageU8a, publicKeyU8a)];
            });
        });
    };
    return SubstrateCryptoClient;
}(CryptoClient_1.CryptoClient));
exports.SubstrateCryptoClient = SubstrateCryptoClient;
//# sourceMappingURL=SubstrateCryptoClient.js.map