"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_0_19_0_1 = require("../../../../dependencies/src/axios-0.19.0");
var bignumber_1 = require("../../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var IAirGapTransaction_1 = require("../../../../interfaces/IAirGapTransaction");
var SubstrateBlockExplorerClient = /** @class */ (function () {
    function SubstrateBlockExplorerClient(network, apiUrl) {
        this.network = network;
        this.apiUrl = apiUrl;
    }
    SubstrateBlockExplorerClient.prototype.getTransactions = function (address, limit, protocolDecimals, cursor) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var body, responses, transfers, rewardSlash, airGapTransfers, airGapPayouts;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        body = cursor ? { row: limit, page: cursor.page, address: address } : { row: limit, page: 0, address: address };
                        return [4 /*yield*/, Promise.all([
                                axios_0_19_0_1.default.post(this.apiUrl + "/transfers", body),
                                axios_0_19_0_1.default.post(this.apiUrl + "/account/reward_slash", body)
                            ])];
                    case 1:
                        responses = _c.sent();
                        transfers = (_a = responses[0].data.data) === null || _a === void 0 ? void 0 : _a.transfers;
                        rewardSlash = (_b = responses[1].data.data) === null || _b === void 0 ? void 0 : _b.list;
                        airGapTransfers = transfers
                            ? transfers
                                .filter(function (tx) { return tx.module === 'balances'; })
                                .map(function (tx) {
                                return {
                                    from: [tx.from],
                                    to: [tx.to],
                                    isInbound: address.includes(tx.to),
                                    amount: new bignumber_1.default(tx.amount).shiftedBy(protocolDecimals).toFixed(),
                                    timestamp: tx.block_timestamp,
                                    fee: tx.fee,
                                    hash: tx.hash,
                                    blockHeight: tx.block_num,
                                    status: tx.success !== undefined ? (tx.success ? IAirGapTransaction_1.AirGapTransactionStatus.APPLIED : IAirGapTransaction_1.AirGapTransactionStatus.FAILED) : undefined
                                };
                            })
                            : [];
                        airGapPayouts = rewardSlash
                            ? rewardSlash
                                .filter(function (tx) { return tx.event_id === 'Reward'; })
                                .map(function (tx) {
                                return {
                                    from: ['Staking Reward'],
                                    to: [address],
                                    amount: tx.amount,
                                    isInbound: true,
                                    timestamp: tx.block_timestamp,
                                    fee: '0',
                                    hash: tx.extrinsic_hash,
                                    blockHeight: tx.block_num,
                                    status: IAirGapTransaction_1.AirGapTransactionStatus.APPLIED
                                };
                            })
                            : [];
                        return [2 /*return*/, airGapTransfers
                                .concat(airGapPayouts)
                                .sort(function (a, b) { return (a.timestamp !== undefined && b.timestamp !== undefined ? b.timestamp - a.timestamp : 0); })];
                }
            });
        });
    };
    return SubstrateBlockExplorerClient;
}());
exports.SubstrateBlockExplorerClient = SubstrateBlockExplorerClient;
//# sourceMappingURL=SubstrateBlockExplorerClient.js.map