import { SubstrateNetwork } from '../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../scale/SCALEDecoder';
import { SCALEInt } from '../scale/type/SCALEInt';
declare class SubstrateAccountData {
    readonly free: SCALEInt;
    readonly reserved: SCALEInt;
    readonly miscFrozen: SCALEInt;
    readonly feeFrozen: SCALEInt;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<SubstrateAccountData>;
    private constructor();
}
export declare class SubstrateAccountInfo {
    readonly nonce: SCALEInt;
    readonly refcount: SCALEInt;
    readonly data: SubstrateAccountData;
    static decode(network: SubstrateNetwork, runtimeVersion: number | undefined, raw: string): SubstrateAccountInfo;
    private static migrateRefcountLength;
    private constructor();
}
export {};
