/// <reference types="node" />
import { SubstrateNetwork } from '../../../SubstrateNetwork';
export declare type SubstrateAccountId = string | SubstrateAddress;
export declare class SubstrateAddress {
    readonly version: Buffer;
    readonly payload: Buffer;
    readonly checksum: Buffer;
    private static placeholder;
    static createPlaceholder(): SubstrateAddress;
    static from(accountId: SubstrateAccountId, network: SubstrateNetwork): SubstrateAddress;
    static fromPublicKey(payload: Buffer | Uint8Array | string, network: SubstrateNetwork): SubstrateAddress;
    static fromEncoded(encoded: string): SubstrateAddress;
    private static fromBytes;
    private static fromPayload;
    private static generateChecksum;
    private encoded;
    constructor(version: Buffer, payload: Buffer, checksum: Buffer);
    compare(other: SubstrateAccountId): number;
    toString(): string;
    getBufferPublicKey(): Buffer;
    getHexPublicKey(): string;
}
