import { SubstrateNetwork } from '../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../scale/SCALEDecoder';
import { SCALEArray } from '../scale/type/SCALEArray';
import { SCALEData } from '../scale/type/SCALEData';
import { SCALEEnum } from '../scale/type/SCALEEnum';
import { SCALEInt } from '../scale/type/SCALEInt';
import { SCALETuple } from '../scale/type/SCALETuple';
declare enum SubstrateJudgement {
    UNKNOWN = 0,
    FEE_PAID = 1,
    REASONABLE = 2,
    KNOWN_GOOD = 3,
    OUT_OF_DATE = 4,
    LOW_QUALITY = 5,
    ERRORNEOUS = 6
}
export declare class SubstrateIdentityInfo {
    readonly display: SCALEData;
    readonly legal: SCALEData;
    readonly web: SCALEData;
    readonly riot: SCALEData;
    readonly email: SCALEData;
    readonly image: SCALEData;
    readonly twitter: SCALEData;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<SubstrateIdentityInfo>;
    private constructor();
}
export declare class SubstrateRegistration {
    readonly judgements: SCALEArray<SCALETuple<SCALEInt, SCALEEnum<SubstrateJudgement>>>;
    readonly deposit: SCALEInt;
    readonly identityInfo: SubstrateIdentityInfo;
    static decode(network: SubstrateNetwork, runtimeVersion: number | undefined, raw: string): SubstrateRegistration;
    private constructor();
}
export {};
