"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MetadataDecorator = /** @class */ (function () {
    function MetadataDecorator(storageEntries, calls, constants) {
        var _this = this;
        this.storageEntries = new Map(storageEntries.map(function (entry) { return [_this.createMapKey(entry.moduleName, entry.prefix), entry]; }));
        this.calls = new Map(calls.map(function (call) { return [_this.createMapKey(call.moduleName, call.name), call]; }));
        this.constants = new Map(constants.map(function (constant) { return [_this.createMapKey(constant.moduleName, constant.name), constant]; }));
    }
    MetadataDecorator.prototype.storageEntry = function (moduleName, entryName) {
        var key = this.createMapKey(moduleName, entryName);
        return this.storageEntries.get(key);
    };
    MetadataDecorator.prototype.call = function (moduleName, callName) {
        var key = this.createMapKey(moduleName, callName);
        return this.calls.get(key);
    };
    MetadataDecorator.prototype.constant = function (moduleName, constantName) {
        var key = this.createMapKey(moduleName, constantName);
        return this.constants.get(key);
    };
    MetadataDecorator.prototype.createMapKey = function (module, item) {
        return module + "_" + item;
    };
    return MetadataDecorator;
}());
exports.MetadataDecorator = MetadataDecorator;
//# sourceMappingURL=MetadataDecorator.js.map