"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable: max-classes-per-file
var blake2b_1 = require("../../../../../../../utils/blake2b");
var hex_1 = require("../../../../../../../utils/hex");
var xxhash_1 = require("../../../../../../../utils/xxhash");
var SubstrateStorageEntryHasher;
(function (SubstrateStorageEntryHasher) {
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["BLAKE2_128"] = 0] = "BLAKE2_128";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["BLAKE2_256"] = 1] = "BLAKE2_256";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["BLAKE2_128_CONCAT"] = 2] = "BLAKE2_128_CONCAT";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["TWOX128"] = 3] = "TWOX128";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["TWOX256"] = 4] = "TWOX256";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["TWOX64_CONCAT"] = 5] = "TWOX64_CONCAT";
    SubstrateStorageEntryHasher[SubstrateStorageEntryHasher["IDENTITY"] = 6] = "IDENTITY";
})(SubstrateStorageEntryHasher = exports.SubstrateStorageEntryHasher || (exports.SubstrateStorageEntryHasher = {}));
var hasherMethods = new Map([
    [SubstrateStorageEntryHasher.BLAKE2_128, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, blake2b_1.blake2bAsHex(value, 128)];
        }); }); }],
    [SubstrateStorageEntryHasher.BLAKE2_256, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, blake2b_1.blake2bAsHex(value, 256)];
        }); }); }],
    [SubstrateStorageEntryHasher.BLAKE2_128_CONCAT, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, blake2b_1.blake2bAsHex(value, 128) + hex_1.bytesToHex(value)];
        }); }); }],
    [SubstrateStorageEntryHasher.TWOX128, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, xxhash_1.xxhashAsHex(value, 128)];
        }); }); }],
    [SubstrateStorageEntryHasher.TWOX256, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, xxhash_1.xxhashAsHex(value, 256)];
        }); }); }],
    [SubstrateStorageEntryHasher.TWOX64_CONCAT, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, xxhash_1.xxhashAsHex(value, 64) + hex_1.bytesToHex(value)];
        }); }); }],
    [SubstrateStorageEntryHasher.IDENTITY, function (value) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, hex_1.bytesToHex(value)];
        }); }); }]
]);
var PREFIX_TRIE_HASH_SIZE = 128;
var SubstrateStorageEntry = /** @class */ (function () {
    function SubstrateStorageEntry(moduleName, prefix) {
        this.moduleName = moduleName;
        this.prefix = prefix;
        this.storageHash = new Map();
    }
    SubstrateStorageEntry.prototype.hash = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var rawKey, _a, prefixTrie, itemHash;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.moduleName + this.prefix;
                        return [4 /*yield*/, this.argsToKeys(args)];
                    case 1:
                        rawKey = _a + (_b.sent());
                        if (!!this.storageHash.get(rawKey)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.hashPrefixTrie()];
                    case 2:
                        prefixTrie = _b.sent();
                        return [4 /*yield*/, this.hashArgs(args)];
                    case 3:
                        itemHash = _b.sent();
                        this.storageHash.set(rawKey, prefixTrie + itemHash);
                        _b.label = 4;
                    case 4: return [2 /*return*/, this.storageHash.get(rawKey)];
                }
            });
        });
    };
    SubstrateStorageEntry.prototype.hashPrefixTrie = function () {
        return __awaiter(this, void 0, void 0, function () {
            var moduleHash, storageHash;
            return __generator(this, function (_a) {
                moduleHash = xxhash_1.xxhashAsHex(this.moduleName, PREFIX_TRIE_HASH_SIZE);
                storageHash = xxhash_1.xxhashAsHex(this.prefix, PREFIX_TRIE_HASH_SIZE);
                return [2 /*return*/, moduleHash + storageHash];
            });
        });
    };
    return SubstrateStorageEntry;
}());
exports.SubstrateStorageEntry = SubstrateStorageEntry;
var SubstratePlainStorageEntry = /** @class */ (function (_super) {
    __extends(SubstratePlainStorageEntry, _super);
    function SubstratePlainStorageEntry() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SubstratePlainStorageEntry.prototype.argsToKeys = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, ''];
            });
        });
    };
    SubstratePlainStorageEntry.prototype.hashArgs = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, ''];
            });
        });
    };
    return SubstratePlainStorageEntry;
}(SubstrateStorageEntry));
exports.SubstratePlainStorageEntry = SubstratePlainStorageEntry;
var SubstrateMapStorageEntry = /** @class */ (function (_super) {
    __extends(SubstrateMapStorageEntry, _super);
    function SubstrateMapStorageEntry(module, prefix, hasher) {
        var _this = _super.call(this, module, prefix) || this;
        _this.hasher = hasher;
        return _this;
    }
    SubstrateMapStorageEntry.prototype.argsToKeys = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, hex_1.bytesToHex(args[0].encode())];
            });
        });
    };
    SubstrateMapStorageEntry.prototype.hashArgs = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var hasherMethod;
            return __generator(this, function (_a) {
                hasherMethod = hasherMethods.get(this.hasher);
                return [2 /*return*/, hasherMethod ? hasherMethod(args[0].encode()) : ''];
            });
        });
    };
    return SubstrateMapStorageEntry;
}(SubstrateStorageEntry));
exports.SubstrateMapStorageEntry = SubstrateMapStorageEntry;
var SubstrateDoubleMapStorageEntry = /** @class */ (function (_super) {
    __extends(SubstrateDoubleMapStorageEntry, _super);
    function SubstrateDoubleMapStorageEntry(module, prefix, firstHasher, secondHasher) {
        var _this = _super.call(this, module, prefix) || this;
        _this.firstHasher = firstHasher;
        _this.secondHasher = secondHasher;
        return _this;
    }
    SubstrateDoubleMapStorageEntry.prototype.argsToKeys = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, hex_1.bytesToHex(args[0].encode()) + hex_1.bytesToHex(args[1].encode())];
            });
        });
    };
    SubstrateDoubleMapStorageEntry.prototype.hashArgs = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var firstHasherMethod, secondHasherMethod;
            return __generator(this, function (_a) {
                firstHasherMethod = hasherMethods.get(this.firstHasher);
                secondHasherMethod = hasherMethods.get(this.secondHasher);
                return [2 /*return*/, firstHasherMethod && secondHasherMethod
                        ? Promise.all([firstHasherMethod(args[0].encode()), secondHasherMethod(args[1].encode())]).then(function (_a) {
                            var firstHash = _a[0], secondHash = _a[1];
                            return firstHash + secondHash;
                        })
                        : ''];
            });
        });
    };
    return SubstrateDoubleMapStorageEntry;
}(SubstrateStorageEntry));
exports.SubstrateDoubleMapStorageEntry = SubstrateDoubleMapStorageEntry;
//# sourceMappingURL=SubstrateStorageEntry.js.map