import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { SCALEArray } from '../../scale/type/SCALEArray';
import { SCALEInt } from '../../scale/type/SCALEInt';
import { SCALEType } from '../../scale/type/SCALEType';
import { MetadataDecorator } from '../decorator/MetadataDecorator';
import { MetadataVersioned } from '../MetadataVersioned';
import { MetadataV11Module } from './module/MetadataV11Module';
export declare class MetadataV11 extends MetadataVersioned {
    readonly magicNumber: SCALEInt;
    readonly version: SCALEInt;
    readonly modules: SCALEArray<MetadataV11Module>;
    static decode(network: SubstrateNetwork, raw: string): MetadataV11;
    protected scaleFields: SCALEType[];
    protected constructor(magicNumber: SCALEInt, version: SCALEInt, modules: SCALEArray<MetadataV11Module>);
    decorate(): MetadataDecorator;
    private createDecoratedStorageEntries;
    private createDecoratedCalls;
    private createDecoratedConstants;
}
