import { SubstrateNetwork } from '../../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../../scale/SCALEDecoder';
import { SCALEArray } from '../../../scale/type/SCALEArray';
import { SCALEClass } from '../../../scale/type/SCALEClass';
import { SCALEString } from '../../../scale/type/SCALEString';
declare class MetadataV11CallArgument extends SCALEClass {
    readonly name: SCALEString;
    readonly type: SCALEString;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11CallArgument>;
    protected scaleFields: SCALEString[];
    private constructor();
}
export declare class MetadataV11Call extends SCALEClass {
    readonly name: SCALEString;
    readonly args: SCALEArray<MetadataV11CallArgument>;
    readonly docs: SCALEArray<SCALEString>;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11Call>;
    protected scaleFields: (SCALEString | SCALEArray<MetadataV11CallArgument>)[];
    private constructor();
}
export {};
