import { SubstrateNetwork } from '../../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../../scale/SCALEDecoder';
import { SCALEArray } from '../../../scale/type/SCALEArray';
import { SCALEClass } from '../../../scale/type/SCALEClass';
import { SCALEOptional } from '../../../scale/type/SCALEOptional';
import { SCALEString } from '../../../scale/type/SCALEString';
import { SCALEType } from '../../../scale/type/SCALEType';
import { MetadataV11Call } from './MetadataV11Call';
import { MetadataV11Constant } from './MetadataV11Constants';
import { MetadataV11Error } from './MetadataV11Error';
import { MetadataV11Event } from './MetadataV11Event';
import { MetadataV11Storage } from './storage/MetadataV11Storage';
export declare class MetadataV11Module extends SCALEClass {
    readonly name: SCALEString;
    readonly storage: SCALEOptional<MetadataV11Storage>;
    readonly calls: SCALEOptional<SCALEArray<MetadataV11Call>>;
    readonly events: SCALEOptional<SCALEArray<MetadataV11Event>>;
    readonly constants: SCALEArray<MetadataV11Constant>;
    readonly errors: SCALEArray<MetadataV11Error>;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11Module>;
    protected scaleFields: SCALEType[];
    protected constructor(name: SCALEString, storage: SCALEOptional<MetadataV11Storage>, calls: SCALEOptional<SCALEArray<MetadataV11Call>>, events: SCALEOptional<SCALEArray<MetadataV11Event>>, constants: SCALEArray<MetadataV11Constant>, errors: SCALEArray<MetadataV11Error>);
}
