import { SubstrateNetwork } from '../../../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../../../scale/SCALEDecoder';
import { SCALEArray } from '../../../../scale/type/SCALEArray';
import { SCALEBytes } from '../../../../scale/type/SCALEBytes';
import { SCALEClass } from '../../../../scale/type/SCALEClass';
import { SCALEEnum } from '../../../../scale/type/SCALEEnum';
import { SCALEString } from '../../../../scale/type/SCALEString';
import { MetadataV11StorageEntryType } from './MetadataV11StorageEntryType';
declare enum StorageEntryModifier {
    Optional = 0,
    Default = 1
}
export declare class MetadataV11StorageEntry extends SCALEClass {
    readonly name: SCALEString;
    readonly modifier: SCALEEnum<StorageEntryModifier>;
    readonly type: MetadataV11StorageEntryType;
    readonly defaultValue: SCALEBytes;
    readonly docs: SCALEArray<SCALEString>;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11StorageEntry>;
    protected scaleFields: (SCALEBytes | SCALEString | MetadataV11StorageEntryType | SCALEEnum<StorageEntryModifier>)[];
    private constructor();
}
export {};
