import { SubstrateNetwork } from '../../../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../../../scale/SCALEDecoder';
import { SCALEBoolean } from '../../../../scale/type/SCALEBoolean';
import { SCALEClass } from '../../../../scale/type/SCALEClass';
import { SCALEEnum } from '../../../../scale/type/SCALEEnum';
import { SCALEString } from '../../../../scale/type/SCALEString';
import { SCALEType } from '../../../../scale/type/SCALEType';
import { SubstrateStorageEntry, SubstrateStorageEntryHasher } from '../../../decorator/storage/SubstrateStorageEntry';
declare enum StorageEntryType {
    Plain = 0,
    Map = 1,
    DoubleMap = 2
}
export declare abstract class MetadataV11StorageEntryType extends SCALEClass {
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11StorageEntryType>;
    protected abstract readonly type: SCALEEnum<StorageEntryType>;
    protected abstract readonly _scaleFields: SCALEType[];
    protected readonly scaleFields: SCALEType[];
    abstract decorate(moduleName: string, prefix: string): SubstrateStorageEntry;
}
export declare class MetadataV11StorageEntryPlain extends MetadataV11StorageEntryType {
    readonly name: SCALEString;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11StorageEntryPlain>;
    protected readonly type: SCALEEnum<StorageEntryType>;
    protected readonly _scaleFields: SCALEString[];
    private constructor();
    decorate(moduleName: string, prefix: string): SubstrateStorageEntry;
}
export declare class MetadataV11StorageEntryMap extends MetadataV11StorageEntryType {
    readonly hasher: SCALEEnum<SubstrateStorageEntryHasher>;
    readonly key: SCALEString;
    readonly value: SCALEString;
    readonly unused: SCALEBoolean;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11StorageEntryMap>;
    protected readonly type: SCALEEnum<StorageEntryType>;
    protected readonly _scaleFields: (SCALEBoolean | SCALEString | SCALEEnum<SubstrateStorageEntryHasher>)[];
    private constructor();
    decorate(moduleName: string, prefix: string): SubstrateStorageEntry;
}
export declare class MetadataV11StorageEntryDoubleMap extends MetadataV11StorageEntryType {
    readonly hasher1: SCALEEnum<SubstrateStorageEntryHasher>;
    readonly key1: SCALEString;
    readonly key2: SCALEString;
    readonly value: SCALEString;
    readonly hasher2: SCALEEnum<SubstrateStorageEntryHasher>;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV11StorageEntryDoubleMap>;
    protected readonly type: SCALEEnum<StorageEntryType>;
    protected readonly _scaleFields: (SCALEString | SCALEEnum<SubstrateStorageEntryHasher>)[];
    private constructor();
    decorate(moduleName: string, prefix: string): SubstrateStorageEntry;
}
export {};
