import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { SCALEArray } from '../../scale/type/SCALEArray';
import { SCALEInt } from '../../scale/type/SCALEInt';
import { MetadataDecorator } from '../decorator/MetadataDecorator';
import { MetadataVersioned } from '../MetadataVersioned';
import { MetadataV12Module } from './module/MetadataV12Module';
export declare class MetadataV12 extends MetadataVersioned {
    readonly magicNumber: SCALEInt;
    readonly version: SCALEInt;
    readonly modules: SCALEArray<MetadataV12Module>;
    static decode(network: SubstrateNetwork, raw: string): MetadataV12;
    protected scaleFields: SCALEInt[];
    protected constructor(magicNumber: SCALEInt, version: SCALEInt, modules: SCALEArray<MetadataV12Module>);
    decorate(): MetadataDecorator;
    private createDecoratedStorageEntries;
    private createDecoratedCalls;
    private createDecoratedConstants;
}
