import { SubstrateNetwork } from '../../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../../scale/SCALEDecoder';
import { SCALEArray } from '../../../scale/type/SCALEArray';
import { SCALEInt } from '../../../scale/type/SCALEInt';
import { SCALEOptional } from '../../../scale/type/SCALEOptional';
import { SCALEString } from '../../../scale/type/SCALEString';
import { SCALEType } from '../../../scale/type/SCALEType';
import { MetadataV11Call } from '../../v11/module/MetadataV11Call';
import { MetadataV11Constant } from '../../v11/module/MetadataV11Constants';
import { MetadataV11Error } from '../../v11/module/MetadataV11Error';
import { MetadataV11Event } from '../../v11/module/MetadataV11Event';
import { MetadataV11Module } from '../../v11/module/MetadataV11Module';
import { MetadataV11Storage } from '../../v11/module/storage/MetadataV11Storage';
export declare class MetadataV12Module extends MetadataV11Module {
    readonly index: SCALEInt;
    static decode(network: SubstrateNetwork, raw: string): SCALEDecodeResult<MetadataV12Module>;
    protected scaleFields: SCALEType[];
    protected constructor(name: SCALEString, storage: SCALEOptional<MetadataV11Storage>, calls: SCALEOptional<SCALEArray<MetadataV11Call>>, events: SCALEOptional<SCALEArray<MetadataV11Event>>, constants: SCALEArray<MetadataV11Constant>, errors: SCALEArray<MetadataV11Error>, index: SCALEInt);
}
