/// <reference types="node" />
import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { SubstrateAddress } from '../../account/SubstrateAddress';
import { SCALEDecodeResult } from '../SCALEDecoder';
import { SCALEType } from './SCALEType';
export declare class SCALEAccountId extends SCALEType {
    readonly address: SubstrateAddress;
    static from(value: string | Uint8Array | Buffer | SubstrateAddress, network: SubstrateNetwork): SCALEAccountId;
    static decode(network: SubstrateNetwork, hex: string): SCALEDecodeResult<SCALEAccountId>;
    private constructor();
    compare(other: SCALEAccountId): number;
    asAddress(): string;
    asBytes(): Buffer;
    toString(): string;
    protected _encode(): string;
}
