"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SubstrateAddress_1 = require("../../account/SubstrateAddress");
var SCALEType_1 = require("./SCALEType");
var SCALEAccountId = /** @class */ (function (_super) {
    __extends(SCALEAccountId, _super);
    function SCALEAccountId(address) {
        var _this = _super.call(this) || this;
        _this.address = address;
        return _this;
    }
    SCALEAccountId.from = function (value, network) {
        var address = value instanceof SubstrateAddress_1.SubstrateAddress ? value : SubstrateAddress_1.SubstrateAddress.from(hex_1.bytesToHex(value), network);
        return new SCALEAccountId(address);
    };
    SCALEAccountId.decode = function (network, hex) {
        var _hex = hex_1.stripHexPrefix(hex);
        return {
            bytesDecoded: 32,
            decoded: SCALEAccountId.from(_hex.substr(0, 64), network)
        };
    };
    SCALEAccountId.prototype.compare = function (other) {
        return this.address.compare(other.address);
    };
    SCALEAccountId.prototype.asAddress = function () {
        return this.address.toString();
    };
    SCALEAccountId.prototype.asBytes = function () {
        return this.address.getBufferPublicKey();
    };
    SCALEAccountId.prototype.toString = function () {
        return this.address.getHexPublicKey();
    };
    SCALEAccountId.prototype._encode = function () {
        return this.address.getHexPublicKey();
    };
    return SCALEAccountId;
}(SCALEType_1.SCALEType));
exports.SCALEAccountId = SCALEAccountId;
//# sourceMappingURL=SCALEAccountId.js.map