"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SCALECompactInt_1 = require("./SCALECompactInt");
var SCALEType_1 = require("./SCALEType");
var SCALEArray = /** @class */ (function (_super) {
    __extends(SCALEArray, _super);
    function SCALEArray(elements) {
        var _this = _super.call(this) || this;
        _this.elements = elements;
        return _this;
    }
    SCALEArray.from = function (elements) {
        return new SCALEArray(elements);
    };
    SCALEArray.decode = function (network, hex, decodeElement) {
        var _hex = hex_1.stripHexPrefix(hex);
        var arrayLength = SCALECompactInt_1.SCALECompactInt.decode(_hex);
        _hex = _hex.slice(arrayLength.bytesDecoded * 2);
        var elements = [];
        var bytesDecoded = 0;
        for (var i = 0; i < arrayLength.decoded.toNumber(); i++) {
            var element = decodeElement(network, _hex);
            elements.push(element.decoded);
            bytesDecoded += element.bytesDecoded;
            _hex = _hex.slice(element.bytesDecoded * 2);
        }
        return {
            bytesDecoded: arrayLength.bytesDecoded + bytesDecoded,
            decoded: SCALEArray.from(elements)
        };
    };
    SCALEArray.prototype.toString = function () {
        return JSON.stringify(this.elements.map(function (element) {
            var elementString = element.toString();
            try {
                elementString = JSON.parse(elementString);
            }
            catch (_a) { }
            return elementString;
        }));
    };
    SCALEArray.prototype._encode = function () {
        return SCALECompactInt_1.SCALECompactInt.from(this.elements.length).encode() + this.elements.map(function (element) { return element.encode(); }).join('');
    };
    return SCALEArray;
}(SCALEType_1.SCALEType));
exports.SCALEArray = SCALEArray;
//# sourceMappingURL=SCALEArray.js.map