"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SCALECompactInt_1 = require("./SCALECompactInt");
var SCALEType_1 = require("./SCALEType");
var SCALEBytes = /** @class */ (function (_super) {
    __extends(SCALEBytes, _super);
    function SCALEBytes(bytes) {
        var _this = _super.call(this) || this;
        _this.bytes = bytes;
        return _this;
    }
    SCALEBytes.from = function (bytes) {
        var buffer;
        if (typeof bytes === 'string' && hex_1.isHex(bytes)) {
            buffer = Buffer.from(hex_1.stripHexPrefix(bytes), 'hex');
        }
        else if (!(typeof bytes === 'string')) {
            buffer = Buffer.from(bytes);
        }
        else {
            throw new Error('SCALEBytes#from: Unknown bytes type.');
        }
        return new SCALEBytes(buffer);
    };
    SCALEBytes.decode = function (hex) {
        var _hex = hex_1.stripHexPrefix(hex);
        var length = SCALECompactInt_1.SCALECompactInt.decode(_hex);
        var bytes = _hex.substr(length.bytesDecoded * 2, length.decoded.toNumber() * 2);
        return {
            bytesDecoded: length.bytesDecoded + length.decoded.toNumber(),
            decoded: SCALEBytes.from(bytes)
        };
    };
    SCALEBytes.prototype.toString = function (encoding) {
        if (encoding === void 0) { encoding = 'hex'; }
        return this.bytes.toString(encoding);
    };
    SCALEBytes.prototype._encode = function () {
        return SCALECompactInt_1.SCALECompactInt.from(this.bytes.length).encode() + this.bytes.toString('hex');
    };
    return SCALEBytes;
}(SCALEType_1.SCALEType));
exports.SCALEBytes = SCALEBytes;
//# sourceMappingURL=SCALEBytes.js.map