"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var hex_1 = require("../../../../../../utils/hex");
var padStart_1 = require("../../../../../../utils/padStart");
var SCALEType_1 = require("./SCALEType");
var SCALECompactInt = /** @class */ (function (_super) {
    __extends(SCALECompactInt, _super);
    function SCALECompactInt(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    SCALECompactInt.from = function (value) {
        return new SCALECompactInt(bignumber_1.default.isBigNumber(value) ? value : new bignumber_1.default(value));
    };
    SCALECompactInt.decode = function (hex) {
        var _hex = hex_1.stripHexPrefix(hex);
        var firstByte = padStart_1.padStart(parseInt(_hex.substr(0, 2), 16).toString(2), 8, '0');
        var mode = parseInt(firstByte.slice(-2), 2);
        var bytes;
        var metaBits;
        if (mode === 3) {
            bytes = parseInt(firstByte.slice(0, -2), 2) + 5; // + 4 bytes of original length + 1 byte of meta
            metaBits = 8;
        }
        else {
            bytes = 1 << mode;
            metaBits = 2;
        }
        var encodedHex = _hex.substr(0, bytes * 2);
        var encodedBin = padStart_1.padStart(new bignumber_1.default(hex_1.changeEndianness(encodedHex), 16).toString(2), metaBits + 1, '0');
        return {
            bytesDecoded: bytes,
            decoded: SCALECompactInt.from(new bignumber_1.default(encodedBin.slice(0, -metaBits), 2))
        };
    };
    SCALECompactInt.prototype.toString = function (base) {
        if (base === void 0) { base = 10; }
        return this.value.toString(base);
    };
    SCALECompactInt.prototype.toNumber = function () {
        return this.value.toNumber();
    };
    SCALECompactInt.prototype.plus = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.plus);
    };
    SCALECompactInt.prototype.minus = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.minus);
    };
    SCALECompactInt.prototype.multiply = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.multipliedBy);
    };
    SCALECompactInt.prototype.divide = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.dividedBy);
    };
    SCALECompactInt.prototype.lt = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.lt);
    };
    SCALECompactInt.prototype.lte = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.lte);
    };
    SCALECompactInt.prototype.gt = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.gt);
    };
    SCALECompactInt.prototype.gte = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.gte);
    };
    SCALECompactInt.prototype.eq = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.eq);
    };
    SCALECompactInt.prototype._encode = function () {
        var bits = this.value.toString(2).length;
        var mode;
        if (bits <= 6) {
            // 0b00: single-byte mode, upper six bits are the LE encoding of the value (valid only for values of 0-63)
            mode = 0;
        }
        else if (bits <= 14) {
            // 0b01: two-byte mode: upper six bits and the following byte is the LE encoding of the value (valid only for values 64-(2**14-1))
            mode = 1;
        }
        else if (bits <= 30) {
            // 0b10: four-byte mode: upper six bits and the following three bytes are the LE encoding of the value (valid only for values (2**14)-(2**30-1))
            mode = 2;
        }
        else {
            // 0b11: Big-integer mode: The upper six bits are the number of bytes following, less four. The value is contained, LE encoded, in the bytes following. The final (most significant) byte must be non-zero. Valid only for values (2**30)-(2**536-1)
            mode = 3;
        }
        var value;
        if (mode == 3) {
            var bytes = Math.ceil(bits / 8);
            value = this.value.multipliedBy(64).plus(bytes - 4); // value << 6 + number of bytes less 4
        }
        else {
            value = this.value;
        }
        var encodedValue = value.multipliedBy(4).plus(mode); // value << 2 + mode
        return hex_1.changeEndianness(encodedValue.toString(16));
    };
    SCALECompactInt.prototype.applyOperation = function (other, operation) {
        return new SCALECompactInt(this.performOperation(other, operation));
    };
    SCALECompactInt.prototype.performOperation = function (other, operation) {
        if (typeof other === 'number' || bignumber_1.default.isBigNumber(other)) {
            return operation.apply(this.value, [other]);
        }
        else {
            return this.performOperation(other.value, operation);
        }
    };
    return SCALECompactInt;
}(SCALEType_1.SCALEType));
exports.SCALECompactInt = SCALECompactInt;
//# sourceMappingURL=SCALECompactInt.js.map