/// <reference types="node" />
import { SCALEDecodeResult } from '../SCALEDecoder';
import { SCALEType } from './SCALEType';
export declare enum SCALEDataType {
    None = 0,
    Raw = 1,
    BlakeTwo256 = 2,
    Sha256 = 3,
    Keccak256 = 4,
    ShaThree256 = 5
}
export declare class SCALEData extends SCALEType {
    readonly type: SCALEDataType;
    readonly bytes: Buffer | null;
    static from(type: SCALEDataType, bytes?: string | Uint8Array | Buffer): SCALEData;
    static decode(hex: string): SCALEDecodeResult<SCALEData>;
    constructor(type: SCALEDataType, bytes: Buffer | null);
    toString(): string;
    protected _encode(): string;
}
