"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SCALEType_1 = require("./SCALEType");
var SCALEHash = /** @class */ (function (_super) {
    __extends(SCALEHash, _super);
    function SCALEHash(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    SCALEHash.empty = function (bitLength) {
        if (bitLength === void 0) { bitLength = 0; }
        var byteLength = Math.ceil(bitLength / 8);
        var u8a = new Uint8Array(byteLength);
        u8a.fill(0);
        return new SCALEHash(Buffer.from(u8a));
    };
    SCALEHash.from = function (bytes) {
        var buffer;
        if (typeof bytes === 'string' && hex_1.isHex(bytes)) {
            buffer = Buffer.from(hex_1.stripHexPrefix(bytes), 'hex');
        }
        else if (!(typeof bytes === 'string')) {
            buffer = Buffer.from(bytes);
        }
        else {
            throw new Error('SCALEHash#from: Unknown bytes type.');
        }
        return new SCALEHash(buffer);
    };
    SCALEHash.decode = function (hex, bitLength) {
        var _hex = hex_1.stripHexPrefix(hex);
        var nibbles = Math.ceil(bitLength / 4);
        var hash = _hex.substr(0, nibbles);
        return {
            bytesDecoded: Math.ceil(nibbles / 2),
            decoded: SCALEHash.from(hash)
        };
    };
    Object.defineProperty(SCALEHash.prototype, "isEmpty", {
        get: function () {
            return this.value.length === 0 || this.value.every(function (value) { return value === 0; });
        },
        enumerable: true,
        configurable: true
    });
    SCALEHash.prototype.toString = function (encoding) {
        if (encoding === void 0) { encoding = 'hex'; }
        return this.value.toString(encoding);
    };
    SCALEHash.prototype._encode = function () {
        return this.value.toString('hex');
    };
    return SCALEHash;
}(SCALEType_1.SCALEType));
exports.SCALEHash = SCALEHash;
//# sourceMappingURL=SCALEHash.js.map