"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var hex_1 = require("../../../../../../utils/hex");
var SCALEType_1 = require("./SCALEType");
var SCALEInt = /** @class */ (function (_super) {
    __extends(SCALEInt, _super);
    function SCALEInt(value, bitLength) {
        var _this = _super.call(this) || this;
        _this.value = value;
        _this.bitLength = bitLength;
        return _this;
    }
    SCALEInt.from = function (value, bitLength) {
        return new SCALEInt(bignumber_1.default.isBigNumber(value) ? value : new bignumber_1.default(value), bitLength);
    };
    SCALEInt.decode = function (hex, bitLength) {
        var _hex = hex_1.stripHexPrefix(hex);
        var nibbles = bitLength ? Math.ceil(bitLength / 4) : _hex.length;
        _hex = hex_1.changeEndianness(hex_1.stripHexPrefix(hex).substr(0, nibbles));
        var decoded = new bignumber_1.default(_hex, 16);
        return {
            bytesDecoded: Math.ceil(nibbles / 2),
            decoded: SCALEInt.from(decoded, bitLength)
        };
    };
    SCALEInt.prototype.toString = function (base) {
        if (base === void 0) { base = 10; }
        return this.value.toString(base);
    };
    SCALEInt.prototype.toNumber = function () {
        return this.value.toNumber();
    };
    SCALEInt.prototype.plus = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.plus);
    };
    SCALEInt.prototype.minus = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.minus);
    };
    SCALEInt.prototype.multiply = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.multipliedBy);
    };
    SCALEInt.prototype.divide = function (other) {
        return this.applyOperation(other, bignumber_1.default.prototype.dividedBy);
    };
    SCALEInt.prototype.lt = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.lt);
    };
    SCALEInt.prototype.lte = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.lte);
    };
    SCALEInt.prototype.gt = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.gt);
    };
    SCALEInt.prototype.gte = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.gte);
    };
    SCALEInt.prototype.eq = function (other) {
        return this.performOperation(other, bignumber_1.default.prototype.eq);
    };
    SCALEInt.prototype._encode = function () {
        var hex = hex_1.toHexStringRaw(this.value, this.bitLength);
        return hex_1.changeEndianness(hex);
    };
    SCALEInt.prototype.applyOperation = function (other, operation) {
        return new SCALEInt(this.performOperation(other, operation));
    };
    SCALEInt.prototype.performOperation = function (other, operation) {
        if (typeof other === 'number' || bignumber_1.default.isBigNumber(other)) {
            return operation.apply(this.value, [other]);
        }
        else {
            return this.performOperation(other.value, operation);
        }
    };
    return SCALEInt;
}(SCALEType_1.SCALEType));
exports.SCALEInt = SCALEInt;
//# sourceMappingURL=SCALEInt.js.map