import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { DecoderMethod, SCALEDecodeResult } from '../SCALEDecoder';
import { SCALEType } from './SCALEType';
export declare enum SCALEOptionalType {
    None = 0,
    Some = 1
}
export declare class SCALEOptional<T extends SCALEType> extends SCALEType {
    readonly value: T | undefined;
    static empty<T extends SCALEType>(): SCALEOptional<T>;
    static from<T extends SCALEType>(value: T): SCALEOptional<T>;
    static decode<T extends SCALEType>(network: SubstrateNetwork, hex: string, decodeValue: DecoderMethod<T>): SCALEDecodeResult<SCALEOptional<T>>;
    private readonly type;
    private constructor();
    toString(): string;
    protected _encode(): string;
}
