"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SCALEType_1 = require("./SCALEType");
var SCALEOptionalType;
(function (SCALEOptionalType) {
    SCALEOptionalType[SCALEOptionalType["None"] = 0] = "None";
    SCALEOptionalType[SCALEOptionalType["Some"] = 1] = "Some";
})(SCALEOptionalType = exports.SCALEOptionalType || (exports.SCALEOptionalType = {}));
var SCALEOptional = /** @class */ (function (_super) {
    __extends(SCALEOptional, _super);
    function SCALEOptional(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        _this.type = value ? 1 : 0;
        return _this;
    }
    SCALEOptional.empty = function () {
        return new SCALEOptional(undefined);
    };
    SCALEOptional.from = function (value) {
        return new SCALEOptional(value);
    };
    SCALEOptional.decode = function (network, hex, decodeValue) {
        var _hex = hex_1.stripHexPrefix(hex);
        var prefix = parseInt(_hex.substr(0, 2), 16);
        switch (prefix) {
            case SCALEOptionalType.None:
                return {
                    bytesDecoded: 1,
                    decoded: SCALEOptional.empty()
                };
            case SCALEOptionalType.Some:
                var value = decodeValue(network, _hex.slice(2));
                return {
                    bytesDecoded: 1 + value.bytesDecoded,
                    decoded: SCALEOptional.from(value.decoded)
                };
            default:
                throw new Error('SCALEOptional#decode: Unknown optional type');
        }
    };
    SCALEOptional.prototype.toString = function () {
        var _a;
        return "Optional<" + (((_a = this.value) === null || _a === void 0 ? void 0 : _a.toString()) || 'EMPTY') + ">";
    };
    SCALEOptional.prototype._encode = function () {
        var _a;
        return hex_1.toHexStringRaw(this.type, 2) + (((_a = this.value) === null || _a === void 0 ? void 0 : _a.encode()) || '');
    };
    return SCALEOptional;
}(SCALEType_1.SCALEType));
exports.SCALEOptional = SCALEOptional;
//# sourceMappingURL=SCALEOptional.js.map