"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../../utils/hex");
var SCALECompactInt_1 = require("./SCALECompactInt");
var SCALEType_1 = require("./SCALEType");
var SCALEString = /** @class */ (function (_super) {
    __extends(SCALEString, _super);
    function SCALEString(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    SCALEString.from = function (value) {
        return new SCALEString(value);
    };
    SCALEString.decode = function (hex) {
        var _hex = hex_1.stripHexPrefix(hex);
        var length = SCALECompactInt_1.SCALECompactInt.decode(_hex);
        _hex = _hex.substr(length.bytesDecoded * 2, length.decoded.toNumber() * 2);
        var decoded = new TextDecoder().decode(Buffer.from(_hex, 'hex'));
        return {
            bytesDecoded: length.bytesDecoded + length.decoded.toNumber(),
            decoded: SCALEString.from(decoded)
        };
    };
    SCALEString.prototype.toCamelCase = function (options) {
        if (options === void 0) { options = { startUpper: false }; }
        return this.value
            .replace(/[-_]+/g, ' ')
            .replace(/(?:^\w|[A-Z]|\b\w)/g, function (match, index) {
            return index === 0 && !options.startUpper ? match.toLowerCase() : match.toUpperCase();
        })
            .replace(/\s+/g, '');
    };
    SCALEString.prototype.toString = function () {
        return this.value;
    };
    SCALEString.prototype._encode = function () {
        var encoded = new TextEncoder().encode(this.value);
        return SCALECompactInt_1.SCALECompactInt.from(this.value.length).encode() + Buffer.from(encoded).toString('hex');
    };
    return SCALEString;
}(SCALEType_1.SCALEType));
exports.SCALEString = SCALEString;
//# sourceMappingURL=SCALEString.js.map