import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { DecoderMethod, SCALEDecodeResult } from '../SCALEDecoder';
import { SCALEType } from './SCALEType';
export declare class SCALETuple<T extends SCALEType, R extends SCALEType> extends SCALEType {
    readonly first: T;
    readonly second: R;
    static from<T extends SCALEType, R extends SCALEType>(first: T, second: R): SCALETuple<T, R>;
    static from<T extends SCALEType, R extends SCALEType>(tuple: [T, R]): SCALETuple<T, R>;
    static decode<T extends SCALEType, R extends SCALEType>(network: SubstrateNetwork, hex: string, decodeFirst: DecoderMethod<T>, decodeSecond: DecoderMethod<R>): SCALEDecodeResult<SCALETuple<T, R>>;
    private constructor();
    toString(): string;
    protected _encode(): string;
}
