"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SCALEDecoder_1 = require("../scale/SCALEDecoder");
var SubstrateElectionStatus;
(function (SubstrateElectionStatus) {
    SubstrateElectionStatus[SubstrateElectionStatus["CLOSED"] = 0] = "CLOSED";
    SubstrateElectionStatus[SubstrateElectionStatus["OPEN"] = 1] = "OPEN";
})(SubstrateElectionStatus = exports.SubstrateElectionStatus || (exports.SubstrateElectionStatus = {}));
var SubstrateEraElectionStatus = /** @class */ (function () {
    function SubstrateEraElectionStatus(status, blockNumber) {
        this.status = status;
        this.blockNumber = blockNumber;
    }
    SubstrateEraElectionStatus.decode = function (network, runtimeVersion, raw) {
        var _a;
        var decoder = new SCALEDecoder_1.SCALEDecoder(network, raw);
        var status = decoder.decodeNextEnum(function (value) { return SubstrateElectionStatus[SubstrateElectionStatus[value]]; });
        var blockNumber;
        if (status.decoded.value === SubstrateElectionStatus.OPEN) {
            blockNumber = decoder.decodeNextInt(32);
        }
        return new SubstrateEraElectionStatus(status.decoded, (_a = blockNumber) === null || _a === void 0 ? void 0 : _a.decoded);
    };
    return SubstrateEraElectionStatus;
}());
exports.SubstrateEraElectionStatus = SubstrateEraElectionStatus;
//# sourceMappingURL=SubstrateEraElectionStatus.js.map