import { IAirGapTransaction } from '../../../../../../interfaces/IAirGapTransaction';
import { SubstrateNetwork } from '../../../../SubstrateNetwork';
import { SCALEDecodeResult } from '../../scale/SCALEDecoder';
import { SCALEClass } from '../../scale/type/SCALEClass';
import { SCALEInt } from '../../scale/type/SCALEInt';
import { SCALEType } from '../../scale/type/SCALEType';
import { SubstrateTransactionType } from '../SubstrateTransaction';
export declare class SubstrateTransactionMethod extends SCALEClass {
    readonly moduleIndex: SCALEInt;
    readonly callIndex: SCALEInt;
    readonly args: [string, SCALEType][];
    readonly toAirGapTransactionParts: () => Partial<IAirGapTransaction>[];
    static create(network: SubstrateNetwork, type: SubstrateTransactionType, moduleIndex: number, callIndex: number, args: any): SubstrateTransactionMethod;
    static decode(network: SubstrateNetwork, type: SubstrateTransactionType, raw: string): SCALEDecodeResult<SubstrateTransactionMethod>;
    protected readonly scaleFields: SCALEType[];
    private constructor();
    toString(): string;
}
