"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ProtocolNetwork_1 = require("../../utils/ProtocolNetwork");
var TezosProtocol_1 = require("./TezosProtocol");
// tslint:disable:max-classes-per-file
var MAINNET_NAME = 'Mainnet';
var NODE_URL = 'https://tezos-node.prod.gke.papers.tech';
var BLOCK_EXPLORER_URL = 'https://tezblock.io';
var INDEXER_API = 'https://tezos-mainnet-conseil.prod.gke.papers.tech';
var INDEXER_APIKEY = 'airgap00391';
var TezosProtocolNetworkExtras = /** @class */ (function () {
    function TezosProtocolNetworkExtras(network, conseilUrl, conseilNetwork, conseilApiKey) {
        if (network === void 0) { network = TezosProtocol_1.TezosNetwork.MAINNET; }
        if (conseilUrl === void 0) { conseilUrl = INDEXER_API; }
        if (conseilNetwork === void 0) { conseilNetwork = TezosProtocol_1.TezosNetwork.MAINNET; }
        if (conseilApiKey === void 0) { conseilApiKey = INDEXER_APIKEY; }
        this.network = network;
        this.conseilUrl = conseilUrl;
        this.conseilNetwork = conseilNetwork;
        this.conseilApiKey = conseilApiKey;
    }
    return TezosProtocolNetworkExtras;
}());
exports.TezosProtocolNetworkExtras = TezosProtocolNetworkExtras;
var TezblockBlockExplorer = /** @class */ (function () {
    function TezblockBlockExplorer(blockExplorer) {
        if (blockExplorer === void 0) { blockExplorer = BLOCK_EXPLORER_URL; }
        this.blockExplorer = blockExplorer;
    }
    TezblockBlockExplorer.prototype.getAddressLink = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.blockExplorer + "/account/" + address];
            });
        });
    };
    TezblockBlockExplorer.prototype.getTransactionLink = function (transactionId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.blockExplorer + "/transaction/" + transactionId];
            });
        });
    };
    return TezblockBlockExplorer;
}());
exports.TezblockBlockExplorer = TezblockBlockExplorer;
var TezosProtocolNetwork = /** @class */ (function (_super) {
    __extends(TezosProtocolNetwork, _super);
    function TezosProtocolNetwork(name, type, rpcUrl, blockExplorer, extras) {
        if (name === void 0) { name = MAINNET_NAME; }
        if (type === void 0) { type = ProtocolNetwork_1.NetworkType.MAINNET; }
        if (rpcUrl === void 0) { rpcUrl = NODE_URL; }
        if (blockExplorer === void 0) { blockExplorer = new TezblockBlockExplorer(); }
        if (extras === void 0) { extras = new TezosProtocolNetworkExtras(); }
        return _super.call(this, name, type, rpcUrl, blockExplorer, extras) || this;
    }
    return TezosProtocolNetwork;
}(ProtocolNetwork_1.ProtocolNetwork));
exports.TezosProtocolNetwork = TezosProtocolNetwork;
// This is used for the TezosFAProtocolConfig
var TezosProtocolConfig = /** @class */ (function () {
    function TezosProtocolConfig() {
        //
    }
    return TezosProtocolConfig;
}());
exports.TezosProtocolConfig = TezosProtocolConfig;
var TezosProtocolOptions = /** @class */ (function () {
    // tslint:disable-next-line:no-unnecessary-initializer
    function TezosProtocolOptions(network, config) {
        if (network === void 0) { network = new TezosProtocolNetwork(); }
        if (config === void 0) { config = new TezosProtocolConfig(); }
        this.network = network;
        this.config = config;
    }
    return TezosProtocolOptions;
}());
exports.TezosProtocolOptions = TezosProtocolOptions;
//# sourceMappingURL=TezosProtocolOptions.js.map