"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var TezosProtocolOptions_1 = require("../TezosProtocolOptions");
var TezosUtils_1 = require("../TezosUtils");
var MichelsonPair_1 = require("../types/michelson/generics/MichelsonPair");
var MichelsonInt_1 = require("../types/michelson/primitives/MichelsonInt");
var TezosFA12Protocol_1 = require("./TezosFA12Protocol");
var TezosFAProtocolOptions_1 = require("./TezosFAProtocolOptions");
var TezosBTCContractEntrypoint;
(function (TezosBTCContractEntrypoint) {
    TezosBTCContractEntrypoint["TOTAL_MINTED"] = "getTotalMinted";
    TezosBTCContractEntrypoint["TOTAL_BURNED"] = "getTotalBurned";
})(TezosBTCContractEntrypoint || (TezosBTCContractEntrypoint = {}));
var TezosBTC = /** @class */ (function (_super) {
    __extends(TezosBTC, _super);
    function TezosBTC(options) {
        if (options === void 0) { options = new TezosFAProtocolOptions_1.TezosFAProtocolOptions(new TezosProtocolOptions_1.TezosProtocolNetwork(), new TezosFAProtocolOptions_1.TezosBTCProtocolConfig()); }
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    TezosBTC.prototype.getTotalMinted = function (source, callbackContract) {
        if (callbackContract === void 0) { callbackContract = this.callbackContract(); }
        return __awaiter(this, void 0, void 0, function () {
            var getTotalMintedCall;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contract.createContractCall(TezosBTCContractEntrypoint.TOTAL_MINTED, [
                            [],
                            callbackContract
                        ])];
                    case 1:
                        getTotalMintedCall = _a.sent();
                        return [2 /*return*/, this.getContractCallIntResult(getTotalMintedCall, this.requireSource(source))];
                }
            });
        });
    };
    TezosBTC.prototype.getTotalBurned = function (source, callbackContract) {
        if (callbackContract === void 0) { callbackContract = this.callbackContract(); }
        return __awaiter(this, void 0, void 0, function () {
            var getTotalBurnedCall;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contract.createContractCall(TezosBTCContractEntrypoint.TOTAL_BURNED, [
                            [],
                            callbackContract
                        ])];
                    case 1:
                        getTotalBurnedCall = _a.sent();
                        return [2 /*return*/, this.getContractCallIntResult(getTotalBurnedCall, this.requireSource(source))];
                }
            });
        });
    };
    TezosBTC.prototype.fetchTokenHolders = function () {
        return __awaiter(this, void 0, void 0, function () {
            var values;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contract.bigMapValues({
                            predicates: [
                                {
                                    field: 'key',
                                    operation: 'startsWith',
                                    set: [TezosBTC.bigMapKeyLedgerPrefix]
                                }
                            ]
                        })];
                    case 1:
                        values = _a.sent();
                        return [2 /*return*/, values
                                .map(function (bigMapEntry) {
                                var addressHex = bigMapEntry.key.substring(TezosBTC.bigMapKeyLedgerPrefix.length);
                                var address = TezosUtils_1.TezosUtils.parseAddress(addressHex);
                                var value = MichelsonInt_1.MichelsonInt.from(0);
                                try {
                                    if (bigMapEntry.value) {
                                        value = TezosUtils_1.TezosUtils.parseHex(bigMapEntry.value);
                                    }
                                }
                                catch (_a) { }
                                if (value instanceof MichelsonPair_1.MichelsonPair) {
                                    value = value.first.get();
                                }
                                var amount = value instanceof MichelsonInt_1.MichelsonInt
                                    ? value.value
                                    : new bignumber_1.default(0);
                                return {
                                    address: address,
                                    amount: amount.toFixed()
                                };
                            })
                                .filter(function (value) { return value.amount !== '0'; })];
                }
            });
        });
    };
    TezosBTC.bigMapKeyLedgerPrefix = '0x05070701000000066c65646765720a00000016';
    return TezosBTC;
}(TezosFA12Protocol_1.TezosFA12Protocol));
exports.TezosBTC = TezosBTC;
//# sourceMappingURL=TezosBTC.js.map