"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../../../dependencies/src/axios-0.19.0/index");
var bignumber_1 = require("../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var ICoinSubProtocol_1 = require("../../ICoinSubProtocol");
var TezosContract_1 = require("../contract/TezosContract");
var TezosProtocol_1 = require("../TezosProtocol");
var TezosOperationType_1 = require("../types/TezosOperationType");
var utils_1 = require("../types/utils");
var TezosFAProtocol = /** @class */ (function (_super) {
    __extends(TezosFAProtocol, _super);
    function TezosFAProtocol(options) {
        var _this = _super.call(this) || this;
        _this.options = options;
        _this.isSubProtocol = true;
        _this.subProtocolType = ICoinSubProtocol_1.SubProtocolType.TOKEN;
        _this.defaultSourceAddress = 'tz1Mj7RzPmMAqDUNFBn5t5VbXmWW4cSUAdtT';
        _this.contractAddress = _this.options.config.contractAddress;
        _this.symbol = _this.options.config.symbol;
        _this.name = _this.options.config.name;
        _this.marketSymbol = _this.options.config.marketSymbol;
        _this.identifier = _this.options.config.identifier;
        _this.feeDefaults = _this.options.config.feeDefaults;
        _this.decimals = _this.options.config.decimals;
        _this.contract = new TezosContract_1.TezosContract(_this.options.config.contractAddress, _this.options.network.rpcUrl, _this.options.network.extras.conseilUrl, _this.options.network.extras.conseilNetwork, _this.options.network.extras.conseilApiKey);
        return _this;
    }
    TezosFAProtocol.prototype.bigMapValue = function (key, isKeyHash, bigMapID) {
        if (isKeyHash === void 0) { isKeyHash = false; }
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contract.bigMapValues({
                            bigMapID: bigMapID,
                            predicates: [
                                {
                                    field: isKeyHash ? 'key_hash' : 'key',
                                    operation: 'eq',
                                    set: [key]
                                }
                            ]
                        })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.length > 0 ? result[0].value : null];
                }
            });
        });
    };
    TezosFAProtocol.prototype.estimateMaxTransactionValueFromPublicKey = function (publicKey, recipients, fee) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getBalanceOfPublicKey(publicKey)];
            });
        });
    };
    TezosFAProtocol.prototype.getTransactionsFromPublicKey = function (publicKey, limit, cursor) {
        return __awaiter(this, void 0, void 0, function () {
            var addresses;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAddressesFromPublicKey(publicKey)];
                    case 1:
                        addresses = _a.sent();
                        return [2 /*return*/, this.getTransactionsFromAddresses(addresses, limit, cursor)];
                }
            });
        });
    };
    TezosFAProtocol.prototype.getTransactionsFromAddresses = function (addresses, limit, cursor) {
        return __awaiter(this, void 0, void 0, function () {
            var allTransactions, lastEntryBlockLevel, transactions;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(addresses.map(function (address) {
                            var body = {
                                predicates: [
                                    {
                                        field: 'parameters',
                                        operation: 'like',
                                        set: [address],
                                        inverse: false
                                    },
                                    {
                                        field: 'parameters_entrypoints',
                                        operation: 'eq',
                                        set: ['transfer'],
                                        inverse: false
                                    },
                                    {
                                        field: 'kind',
                                        operation: 'eq',
                                        set: ['transaction'],
                                        inverse: false
                                    },
                                    {
                                        field: 'destination',
                                        operation: 'eq',
                                        set: [_this.contractAddress],
                                        inverse: false
                                    }
                                ],
                                orderBy: [
                                    {
                                        field: 'timestamp',
                                        direction: 'desc'
                                    }
                                ],
                                limit: limit
                            };
                            if (cursor && cursor.lastBlockLevel) {
                                body.predicates.push({
                                    field: 'block_level',
                                    operation: 'lt',
                                    set: [cursor.lastBlockLevel.toString()],
                                    inverse: false
                                });
                            }
                            return index_1.default
                                .post(_this.baseApiUrl + "/v2/data/tezos/" + _this.baseApiNetwork + "/operations", body, {
                                // incoming txs
                                headers: _this.headers
                            })
                                .then(function (response) { return response.data; })
                                .catch(function () {
                                return [];
                            });
                        }))];
                    case 1:
                        allTransactions = _a.sent();
                        lastEntryBlockLevel = allTransactions.length > 0 ? allTransactions[allTransactions.length - 1].block_level : 0;
                        transactions = allTransactions
                            .reduce(function (current, next) { return current.concat(next); })
                            .map(function (transaction) { return _this.transactionToAirGapTransactions(transaction, addresses); })
                            .reduce(function (flatten, toFlatten) { return flatten.concat(toFlatten); }, []);
                        return [2 /*return*/, {
                                transactions: transactions,
                                cursor: {
                                    lastBlockLevel: lastEntryBlockLevel
                                }
                            }];
                }
            });
        });
    };
    TezosFAProtocol.prototype.getTransactions = function (limit, cursor) {
        return __awaiter(this, void 0, void 0, function () {
            var body, response, transactions, lastEntryBlockLevel;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = {
                            predicates: [
                                {
                                    field: 'parameters',
                                    operation: 'like',
                                    set: ['"transfer"'],
                                    inverse: false
                                },
                                {
                                    field: 'kind',
                                    operation: 'eq',
                                    set: ['transaction'],
                                    inverse: false
                                },
                                {
                                    field: 'destination',
                                    operation: 'eq',
                                    set: [this.contractAddress],
                                    inverse: false
                                }
                            ],
                            orderBy: [
                                {
                                    field: 'block_level',
                                    direction: 'desc'
                                }
                            ],
                            limit: limit
                        };
                        if (cursor !== undefined) {
                            body.predicates.push({
                                field: 'block_level',
                                operation: 'lt',
                                set: [cursor.lastBlockLevel],
                                inverse: false
                            });
                        }
                        return [4 /*yield*/, index_1.default.post(this.baseApiUrl + "/v2/data/tezos/" + this.baseApiNetwork + "/operations", body, {
                                headers: this.headers
                            })];
                    case 1:
                        response = _a.sent();
                        transactions = response.data
                            .map(function (transaction) { return _this.transactionToAirGapTransactions(transaction); })
                            .reduce(function (flatten, toFlatten) { return flatten.concat(toFlatten); }, []);
                        lastEntryBlockLevel = response.data.length > 0 ? response.data[response.data.length - 1].block_level : 0;
                        return [2 /*return*/, {
                                transactions: transactions,
                                cursor: {
                                    lastBlockLevel: lastEntryBlockLevel
                                }
                            }];
                }
            });
        });
    };
    TezosFAProtocol.prototype.normalizeTransactionParameters = function (parameters, fallbackEntrypointName) {
        return __awaiter(this, void 0, void 0, function () {
            var parsedParameters;
            return __generator(this, function (_a) {
                parsedParameters = this.parseParameters(parameters);
                if (!(parsedParameters instanceof Object && 'value' in parsedParameters) && !utils_1.isMichelineNode(parsedParameters)) {
                    throw new Error('Invalid parameters.');
                }
                return [2 /*return*/, this.contract.normalizeContractCallParameters(parsedParameters, fallbackEntrypointName)];
            });
        });
    };
    TezosFAProtocol.prototype.getTransactionOperationDetails = function (transactionOperation) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var partials;
            return __generator(this, function (_b) {
                partials = [];
                try {
                    partials = transactionOperation.parameters
                        ? (_a = this.transactionDetailsFromParameters(transactionOperation.parameters), (_a !== null && _a !== void 0 ? _a : [])) : [];
                }
                catch (_c) { }
                if (partials.length === 0) {
                    partials.push({});
                }
                return [2 /*return*/, partials.map(function (partial) {
                        return __assign({ from: [transactionOperation.source], amount: transactionOperation.amount, to: [transactionOperation.destination] }, partial);
                    })];
            });
        });
    };
    TezosFAProtocol.prototype.parseParameters = function (parameters) {
        var toBeRemoved = 'Unparsable code: ';
        if (parameters.startsWith(toBeRemoved)) {
            parameters = parameters.slice(toBeRemoved.length);
        }
        return JSON.parse(parameters);
    };
    TezosFAProtocol.prototype.transactionToAirGapTransactions = function (transaction, sourceAddresses) {
        var _this = this;
        var _a;
        var parameters = (_a = transaction.parameters_micheline, (_a !== null && _a !== void 0 ? _a : transaction.parameters));
        var parsedParameters = this.parseParameters(parameters);
        if (!utils_1.isMichelineNode(parsedParameters)) {
            throw new Error('Transaction parameters are invalid.');
        }
        var transferData = {
            entrypoint: transaction.parameters_entrypoints,
            value: parsedParameters
        };
        var partialDetails = this.transactionDetailsFromParameters(transferData);
        return partialDetails.map(function (details) {
            var _a;
            var inbound = sourceAddresses !== undefined && details.to && details.to.length === 1 ? sourceAddresses.indexOf(details.to[0]) !== -1 : false;
            return __assign({ amount: new bignumber_1.default(0).toFixed(), fee: new bignumber_1.default((_a = transaction.fee, (_a !== null && _a !== void 0 ? _a : 0))).toFixed(), from: [], isInbound: inbound, protocolIdentifier: _this.identifier, network: _this.options.network, to: [], hash: transaction.operation_group_hash, timestamp: transaction.timestamp / 1000, blockHeight: transaction.block_level, status: transaction.status }, details);
        });
    };
    TezosFAProtocol.prototype.runContractCall = function (contractCall, source) {
        return __awaiter(this, void 0, void 0, function () {
            var results, counter, branch, chainID, body, response, metadata, runOperationError_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all([
                            index_1.default.get(this.url("/chains/main/blocks/head/context/contracts/" + source + "/counter")),
                            index_1.default.get(this.url('/chains/main/blocks/head/'))
                        ])];
                    case 1:
                        results = _a.sent();
                        counter = new bignumber_1.default(results[0].data).plus(1);
                        branch = results[1].data.hash;
                        chainID = results[1].data.chain_id;
                        body = this.prepareMockContractCall(contractCall, chainID, branch, counter, source, this.contractAddress);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, index_1.default.post(this.url('/chains/main/blocks/head/helpers/scripts/run_operation'), body, {
                                headers: { 'Content-Type': 'application/json' }
                            })];
                    case 3:
                        response = _a.sent();
                        metadata = response.data.contents[0].metadata;
                        if (metadata.internal_operation_results !== undefined && metadata.operation_result.status === 'applied') {
                            return [2 /*return*/, metadata.internal_operation_results[0].parameters.value];
                        }
                        else {
                            throw new Error(metadata.operation_result.errors[0].id);
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        runOperationError_1 = _a.sent();
                        console.error(runOperationError_1);
                        throw runOperationError_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    TezosFAProtocol.prototype.prepareContractCall = function (contractCalls, fee, publicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var operations, tezosWrappedOperation, binaryTx, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        operations = contractCalls.map(function (contractCall) {
                            return {
                                kind: TezosOperationType_1.TezosOperationType.TRANSACTION,
                                fee: fee,
                                amount: '0',
                                destination: _this.contractAddress,
                                parameters: contractCall.toJSON()
                            };
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.prepareOperations(publicKey, operations, false)];
                    case 2:
                        tezosWrappedOperation = _a.sent();
                        return [4 /*yield*/, this.forgeTezosOperation(tezosWrappedOperation)];
                    case 3:
                        binaryTx = _a.sent();
                        return [2 /*return*/, { binaryTransaction: binaryTx }];
                    case 4:
                        error_1 = _a.sent();
                        console.error(error_1.message);
                        throw new Error('Forging Tezos TX failed.');
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    TezosFAProtocol.prototype.requireSource = function (source, defaultSource) {
        var excludedPrefixes = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            excludedPrefixes[_i - 2] = arguments[_i];
        }
        var _source = (source !== null && source !== void 0 ? source : defaultSource);
        return _source === undefined || excludedPrefixes.some(function (excluded) { return _source.toLowerCase().startsWith(excluded.toLowerCase()); })
            ? this.defaultSourceAddress
            : _source;
    };
    TezosFAProtocol.prototype.prepareMockContractCall = function (contractCall, chainID, branch, counter, source, contractAddress, fee) {
        if (fee === void 0) { fee = '0'; }
        return {
            chain_id: chainID,
            operation: {
                branch: branch,
                signature: 'sigUHx32f9wesZ1n2BWpixXz4AQaZggEtchaQNHYGRCoWNAXx45WGW2ua3apUUUAGMLPwAU41QoaFCzVSL61VaessLg4YbbP',
                contents: [
                    {
                        kind: TezosOperationType_1.TezosOperationType.TRANSACTION,
                        counter: counter.toFixed(),
                        amount: '0',
                        source: source,
                        destination: contractAddress,
                        fee: fee,
                        gas_limit: '400000',
                        storage_limit: '60000',
                        parameters: contractCall.toJSON()
                    }
                ]
            }
        };
    };
    TezosFAProtocol.prototype.url = function (path) {
        return "" + this.jsonRPCAPI + path;
    };
    return TezosFAProtocol;
}(TezosProtocol_1.TezosProtocol));
exports.TezosFAProtocol = TezosFAProtocol;
//# sourceMappingURL=TezosFAProtocol.js.map