"use strict";
// tslint:disable:max-classes-per-file
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../../../serializer/constants");
var ProtocolSymbols_1 = require("../../../utils/ProtocolSymbols");
var TezosProtocolOptions_1 = require("../TezosProtocolOptions");
var TezosFAProtocolConfig = /** @class */ (function (_super) {
    __extends(TezosFAProtocolConfig, _super);
    function TezosFAProtocolConfig(symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) {
        var _this = _super.call(this) || this;
        _this.symbol = symbol;
        _this.name = name;
        _this.marketSymbol = marketSymbol;
        _this.identifier = identifier;
        _this.contractAddress = contractAddress;
        _this.feeDefaults = feeDefaults;
        _this.decimals = decimals;
        return _this;
    }
    return TezosFAProtocolConfig;
}(TezosProtocolOptions_1.TezosProtocolConfig));
exports.TezosFAProtocolConfig = TezosFAProtocolConfig;
var TezosFA2ProtocolConfig = /** @class */ (function (_super) {
    __extends(TezosFA2ProtocolConfig, _super);
    function TezosFA2ProtocolConfig(symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals, tokenID, tokenMetadataBigMapID, tokenMetadataBigMapName, tokenMetadataBigMapRegex) {
        var _this = _super.call(this, symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) || this;
        _this.symbol = symbol;
        _this.name = name;
        _this.marketSymbol = marketSymbol;
        _this.identifier = identifier;
        _this.contractAddress = contractAddress;
        _this.feeDefaults = feeDefaults;
        _this.decimals = decimals;
        _this.tokenID = tokenID;
        _this.tokenMetadataBigMapID = tokenMetadataBigMapID;
        _this.tokenMetadataBigMapName = tokenMetadataBigMapName;
        _this.tokenMetadataBigMapRegex = tokenMetadataBigMapRegex;
        return _this;
    }
    return TezosFA2ProtocolConfig;
}(TezosFAProtocolConfig));
exports.TezosFA2ProtocolConfig = TezosFA2ProtocolConfig;
var TezosBTCProtocolConfig = /** @class */ (function (_super) {
    __extends(TezosBTCProtocolConfig, _super);
    function TezosBTCProtocolConfig(symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) {
        if (symbol === void 0) { symbol = 'tzBTC'; }
        if (name === void 0) { name = 'Tezos BTC'; }
        if (marketSymbol === void 0) { marketSymbol = 'btc'; }
        if (identifier === void 0) { identifier = ProtocolSymbols_1.SubProtocolSymbols.XTZ_BTC; }
        if (contractAddress === void 0) { contractAddress = constants_1.TezosBTCDetails.CONTRACT_ADDRESS; }
        if (feeDefaults === void 0) { feeDefaults = {
            low: '0.100',
            medium: '0.200',
            high: '0.300'
        }; }
        if (decimals === void 0) { decimals = 8; }
        return _super.call(this, symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) || this;
    }
    return TezosBTCProtocolConfig;
}(TezosFAProtocolConfig));
exports.TezosBTCProtocolConfig = TezosBTCProtocolConfig;
var TezosStakerProtocolConfig = /** @class */ (function (_super) {
    __extends(TezosStakerProtocolConfig, _super);
    function TezosStakerProtocolConfig(symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) {
        if (symbol === void 0) { symbol = 'STKR'; }
        if (name === void 0) { name = 'Staker'; }
        if (marketSymbol === void 0) { marketSymbol = 'stkr'; }
        if (identifier === void 0) { identifier = ProtocolSymbols_1.SubProtocolSymbols.XTZ_BTC; }
        if (contractAddress === void 0) { contractAddress = 'KT1EctCuorV2NfVb1XTQgvzJ88MQtWP8cMMv'; }
        if (feeDefaults === void 0) { feeDefaults = {
            low: '0.100',
            medium: '0.300',
            high: '0.500'
        }; }
        if (decimals === void 0) { decimals = 6; }
        return _super.call(this, symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) || this;
    }
    return TezosStakerProtocolConfig;
}(TezosFAProtocolConfig));
exports.TezosStakerProtocolConfig = TezosStakerProtocolConfig;
var TezosUSDProtocolConfig = /** @class */ (function (_super) {
    __extends(TezosUSDProtocolConfig, _super);
    function TezosUSDProtocolConfig(symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) {
        if (symbol === void 0) { symbol = 'USDtz'; }
        if (name === void 0) { name = 'USD Tez'; }
        if (marketSymbol === void 0) { marketSymbol = 'USDtz'; }
        if (identifier === void 0) { identifier = ProtocolSymbols_1.SubProtocolSymbols.XTZ_USD; }
        if (contractAddress === void 0) { contractAddress = 'KT1LN4LPSqTMS7Sd2CJw4bbDGRkMv2t68Fy9'; }
        if (feeDefaults === void 0) { feeDefaults = {
            low: '0.100',
            medium: '0.300',
            high: '0.500'
        }; }
        if (decimals === void 0) { decimals = 6; }
        return _super.call(this, symbol, name, marketSymbol, identifier, contractAddress, feeDefaults, decimals) || this;
    }
    return TezosUSDProtocolConfig;
}(TezosFAProtocolConfig));
exports.TezosUSDProtocolConfig = TezosUSDProtocolConfig;
var TezosFAProtocolOptions = /** @class */ (function () {
    // tslint:disable-next-line:no-unnecessary-initializer
    function TezosFAProtocolOptions(network, config) {
        if (network === void 0) { network = new TezosProtocolOptions_1.TezosProtocolNetwork(); }
        this.network = network;
        this.config = config;
    }
    return TezosFAProtocolOptions;
}());
exports.TezosFAProtocolOptions = TezosFAProtocolOptions;
var TezosFA2ProtocolOptions = /** @class */ (function () {
    // tslint:disable-next-line:no-unnecessary-initializer
    function TezosFA2ProtocolOptions(network, config) {
        if (network === void 0) { network = new TezosProtocolOptions_1.TezosProtocolNetwork(); }
        this.network = network;
        this.config = config;
    }
    return TezosFA2ProtocolOptions;
}());
exports.TezosFA2ProtocolOptions = TezosFA2ProtocolOptions;
//# sourceMappingURL=TezosFAProtocolOptions.js.map