import BigNumber from '../../../dependencies/src/bignumber.js-9.0.0/bignumber';
import { RawTezosTransaction } from '../../../serializer/types';
import { ProtocolSymbols } from '../../../utils/ProtocolSymbols';
import { FeeDefaults } from '../../ICoinProtocol';
import { ICoinSubProtocol, SubProtocolType } from '../../ICoinSubProtocol';
import { TezosProtocol } from '../TezosProtocol';
export declare class TezosKtProtocol extends TezosProtocol implements ICoinSubProtocol {
    identifier: ProtocolSymbols;
    isSubProtocol: boolean;
    subProtocolType: SubProtocolType;
    addressValidationPattern: string;
    migrationFee: BigNumber;
    getAddressFromPublicKey(publicKey: string): Promise<string>;
    getAddressesFromPublicKey(publicKey: string): Promise<string[]>;
    estimateMaxTransactionValueFromPublicKey(publicKey: string, recipients: string[], fee?: string): Promise<string>;
    estimateFeeDefaultsFromPublicKey(publicKey: string, recipients: string[], values: string[], data?: any): Promise<FeeDefaults>;
    prepareTransactionFromPublicKey(_publicKey: string, _recipients: string[], _values: string[], _fee: string, _data?: {
        addressIndex: number;
    }): Promise<RawTezosTransaction>;
    originate(publicKey: string, delegate?: string, amount?: BigNumber): Promise<RawTezosTransaction>;
    delegate(publicKey: string, delegate?: string): Promise<RawTezosTransaction>;
    migrateKtContract(publicKey: string, destinationContract: string): Promise<{
        binaryTransaction: string;
    }>;
}
