"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var TezosRewardCalculationDefault_1 = require("./TezosRewardCalculationDefault");
var TezosRewardsCalculation005 = /** @class */ (function (_super) {
    __extends(TezosRewardsCalculation005, _super);
    function TezosRewardsCalculation005(protocol) {
        var _this = _super.call(this, protocol) || this;
        _this.protocol = protocol;
        return _this;
    }
    TezosRewardsCalculation005.prototype.computeBakingRewards = function (bakingRights, isFutureCycle) {
        return __awaiter(this, void 0, void 0, function () {
            var result, rewardsByLevel, levels, endorsementCountsAndFees;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = new bignumber_1.default(0);
                        rewardsByLevel = [];
                        levels = bakingRights.map(function (br) { return br.level; });
                        if (!!isFutureCycle) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.fetchEndorsementOperationCountAndTotalFees(levels)];
                    case 1:
                        endorsementCountsAndFees = _a.sent();
                        _a.label = 2;
                    case 2:
                        result = bakingRights.reduce(function (current, next) {
                            // (16 / (priority + 1)) * (0.8 + (0.2 * (e / 32)))
                            var count = _this.tezosNodeConstants.endorsers_per_block;
                            var blockEndorsementCountAndFee;
                            if (!isFutureCycle && endorsementCountsAndFees !== undefined) {
                                blockEndorsementCountAndFee = endorsementCountsAndFees.get(next.level);
                                if (blockEndorsementCountAndFee === undefined) {
                                    throw new Error('Cannot find endorsement operation count');
                                }
                                count = parseInt(blockEndorsementCountAndFee.sum_number_of_slots);
                            }
                            var p = next.priority;
                            var e = count;
                            var bakingReward = _this.specificBakingCalculation(e, p);
                            rewardsByLevel.push({
                                level: next.level,
                                amount: bakingReward.toFixed(),
                                deposit: _this.tezosNodeConstants.block_security_deposit,
                                fees: blockEndorsementCountAndFee !== undefined ? new bignumber_1.default(blockEndorsementCountAndFee.sum_fee).toFixed() : '0'
                            });
                            return current.plus(bakingReward);
                        }, new bignumber_1.default(0));
                        return [2 /*return*/, { totalBakingRewards: result.toFixed(), rewardsDetails: rewardsByLevel }];
                }
            });
        });
    };
    TezosRewardsCalculation005.prototype.specificBakingCalculation = function (e, p) {
        var muliplier = Math.floor(8 + 2 * (e / 32));
        var bakingReward = (this.tezosNodeConstants.block_reward * muliplier) / 10 / (p + 1);
        return new bignumber_1.default(bakingReward);
    };
    TezosRewardsCalculation005.prototype.computeEndorsingRewards = function (endorsingRights, isFutureCycle) {
        return __awaiter(this, void 0, void 0, function () {
            var priorities, rewardsByLevel, levels, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        priorities = [];
                        rewardsByLevel = [];
                        if (!!isFutureCycle) return [3 /*break*/, 2];
                        levels = endorsingRights.map(function (er) {
                            return er.block_level;
                        });
                        if (!(levels.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.fetchBlockPriorities(levels)];
                    case 1:
                        priorities = _a.sent();
                        _a.label = 2;
                    case 2:
                        result = endorsingRights.reduce(function (current, next) {
                            var priority = 0;
                            if (!isFutureCycle) {
                                var block = priorities.find(function (p) { return p.level === next.block_level; });
                                if (block === undefined) {
                                    throw new Error('Cannot find block priority');
                                }
                                priority = block.priority;
                            }
                            var reward = _this.specificEndorsingCalculation(priority, next.number_of_slots);
                            rewardsByLevel.push({
                                level: next.level,
                                amount: reward.toFixed(),
                                deposit: _this.tezosNodeConstants.endorsement_security_deposit
                            });
                            return current.plus(reward);
                        }, new bignumber_1.default(0));
                        return [2 /*return*/, { totalEndorsingRewards: result.toFixed(), rewardsDetails: rewardsByLevel }];
                }
            });
        });
    };
    TezosRewardsCalculation005.prototype.specificEndorsingCalculation = function (priority, number_of_slots) {
        var multiplier = new bignumber_1.default(this.tezosNodeConstants.endorsement_reward).div(new bignumber_1.default(priority + 1));
        var reward = new bignumber_1.default(number_of_slots).times(multiplier);
        return reward;
    };
    return TezosRewardsCalculation005;
}(TezosRewardCalculationDefault_1.TezosRewardsCalculationDefault));
exports.TezosRewardsCalculation005 = TezosRewardsCalculation005;
//# sourceMappingURL=TezosRewardCalculation005.js.map