"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Lazy_1 = require("../../../../../data/Lazy");
var error_1 = require("../../../../../utils/error");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonList = /** @class */ (function (_super) {
    __extends(MichelsonList, _super);
    function MichelsonList(elements, name) {
        var _this = _super.call(this, name) || this;
        _this.elements = elements;
        return _this;
    }
    MichelsonList.from = function (value, mappingFunction, name) {
        if (value instanceof MichelsonList) {
            return value;
        }
        if (!Array.isArray(value)) {
            throw error_1.invalidArgumentTypeError('MichelsonList', 'array', typeof value);
        }
        if (value.some(function (item) { return !(item instanceof MichelsonType_1.MichelsonType); }) && typeof mappingFunction !== 'function') {
            throw new Error('MichelsonList: unknown generic mapping factory function.');
        }
        var lazyList = new Lazy_1.Lazy(function () {
            var elements = value.map(function (element) {
                if (element instanceof MichelsonType_1.MichelsonType) {
                    return element;
                }
                else {
                    return typeof mappingFunction === 'function' ? mappingFunction(element) : undefined;
                }
            });
            if (elements.some(function (element) { return !(element instanceof MichelsonType_1.MichelsonType); })) {
                throw new Error('MichelsonList: unknown generic mapping type.');
            }
            return elements;
        });
        return new MichelsonList(lazyList, name);
    };
    MichelsonList.prototype.asRawValue = function () {
        var _a;
        var value = this.elements.get().map(function (element) { return element.asRawValue(); });
        return this.name ? (_a = {}, _a[this.name] = value, _a) : value;
    };
    MichelsonList.prototype.toMichelineJSON = function () {
        return this.elements.get().map(function (element) { return element.toMichelineJSON(); });
    };
    MichelsonList.prototype.eval = function () {
        this.elements.get();
    };
    return MichelsonList;
}(MichelsonType_1.MichelsonType));
exports.MichelsonList = MichelsonList;
//# sourceMappingURL=MichelsonList.js.map