import { Lazy } from '../../../../../data/Lazy';
import { MichelineDataNode, MichelinePrimitiveApplication } from '../../micheline/MichelineNode';
import { MichelsonGrammarData } from '../grammar/MichelsonGrammarData';
import { MichelsonType } from '../MichelsonType';
export declare type MichelsonOptionType = 'Some' | 'None';
export declare abstract class MichelsonOption extends MichelsonType {
    protected abstract type: MichelsonOptionType;
    static from(value: unknown, mappingFunction?: unknown, name?: string): MichelsonOption;
    static fromMicheline(micheline: MichelinePrimitiveApplication<MichelsonGrammarData>, mappingFunction: unknown, name?: string): MichelsonOption;
    static fromUnknown(unknownValue: unknown, mappingFunction: unknown, name?: string): MichelsonOption;
}
export declare class MichelsonSome extends MichelsonOption {
    readonly value: Lazy<MichelsonType>;
    protected type: MichelsonOptionType;
    constructor(value: Lazy<MichelsonType>, name?: string);
    asRawValue(): any;
    toMichelineJSON(): MichelineDataNode;
    eval(): void;
}
export declare class MichelsonNone extends MichelsonOption {
    protected type: MichelsonOptionType;
    asRawValue(): Record<string, null> | null;
    toMichelineJSON(): MichelineDataNode;
}
