import { Lazy } from '../../../../../data/Lazy';
import { MichelineDataNode, MichelinePrimitiveApplication } from '../../micheline/MichelineNode';
import { MichelsonGrammarData } from '../grammar/MichelsonGrammarData';
import { MichelsonType } from '../MichelsonType';
export declare type MichelsonOrType = 'Left' | 'Right';
export declare abstract class MichelsonOr extends MichelsonType {
    readonly value: Lazy<MichelsonType>;
    protected abstract type: MichelsonOrType;
    constructor(value: Lazy<MichelsonType>, name?: string);
    static from(or: unknown, firstMappingFunction?: unknown, secondMappingFunction?: unknown, name?: string): MichelsonOr;
    static fromMicheline(micheline: MichelinePrimitiveApplication<MichelsonGrammarData>, firstMappingFunction: unknown, secondMappingFunction: unknown, name?: string): MichelsonOr;
    static fromUnknown(unknownValue: unknown, firstMappingFunction: unknown, secondMappingFunction: unknown, name?: string): MichelsonOr;
    static isOr(unknownValue: unknown): unknownValue is MichelsonOr;
    private static create;
    asRawValue(): Record<string, any> | any;
    toMichelineJSON(): MichelineDataNode;
    eval(): void;
}
export declare class MichelsonLeft extends MichelsonOr {
    protected readonly type = "Left";
}
export declare class MichelsonRight extends MichelsonOr {
    protected readonly type = "Right";
}
