import { Lazy } from '../../../../../data/Lazy';
import { MichelineDataNode, MichelinePrimitiveApplication } from '../../micheline/MichelineNode';
import { MichelsonGrammarData } from '../grammar/MichelsonGrammarData';
import { MichelsonType } from '../MichelsonType';
export declare class MichelsonPair extends MichelsonType {
    readonly first: Lazy<MichelsonType>;
    readonly second: Lazy<MichelsonType>;
    constructor(first: Lazy<MichelsonType>, second: Lazy<MichelsonType>, name?: string);
    static from(pair: unknown, firstMappingFunction?: unknown, secondMappingFunction?: unknown, name?: string): MichelsonPair;
    static fromMicheline(micheline: MichelinePrimitiveApplication<MichelsonGrammarData>, firstMappingFunction: unknown, secondMappingFunction: unknown, name?: string): MichelsonPair;
    static fromUnknown(unknownValue: MichelsonType | unknown, firstMappingFunction: unknown, secondMappingFunction: unknown, name?: string): MichelsonPair;
    private static asRawValue;
    asRawValue(): Record<string, any> | [any, any];
    toMichelineJSON(): MichelineDataNode;
    eval(): void;
}
