import { MichelineDataNode, MichelinePrimitive } from '../../micheline/MichelineNode';
import { MichelsonType } from '../MichelsonType';
import { MichelsonBytes } from './MichelsonBytes';
import { MichelsonString } from './MichelsonString';
export declare class MichelsonAddress extends MichelsonType {
    readonly address: MichelsonString | MichelsonBytes;
    constructor(address: MichelsonString | MichelsonBytes, name?: string);
    static from(value: unknown, name?: string): MichelsonAddress;
    static fromMicheline(micheline: MichelinePrimitive<'string'> | MichelinePrimitive<'bytes'>, name?: string): MichelsonAddress;
    static fromUnknown(unknownValue: unknown, name?: string): MichelsonAddress;
    asRawValue(): Record<string, string> | string;
    toMichelineJSON(): MichelineDataNode;
}
