"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var hex_1 = require("../../../../../utils/hex");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonBytes_1 = require("./MichelsonBytes");
var MichelsonString_1 = require("./MichelsonString");
var MichelsonAddress = /** @class */ (function (_super) {
    __extends(MichelsonAddress, _super);
    function MichelsonAddress(address, name) {
        var _this = _super.call(this, name) || this;
        _this.address = address;
        return _this;
    }
    MichelsonAddress.from = function (value, name) {
        return utils_1.isMichelinePrimitive('string', value) || utils_1.isMichelinePrimitive('bytes', value)
            ? MichelsonAddress.fromMicheline(value, name)
            : MichelsonAddress.fromUnknown(value, name);
    };
    MichelsonAddress.fromMicheline = function (micheline, name) {
        var value = utils_1.isMichelinePrimitive('string', micheline)
            ? MichelsonString_1.MichelsonString.fromMicheline(micheline)
            : MichelsonBytes_1.MichelsonBytes.fromMicheline(micheline);
        return new MichelsonAddress(value, name);
    };
    MichelsonAddress.fromUnknown = function (unknownValue, name) {
        if (unknownValue instanceof MichelsonAddress) {
            return unknownValue;
        }
        var value;
        if (typeof unknownValue === 'string' && (unknownValue.toLowerCase().startsWith('tz') || unknownValue.toLowerCase().startsWith('kt'))) {
            value = MichelsonString_1.MichelsonString.from(unknownValue);
        }
        else if ((typeof unknownValue === 'string' && hex_1.isHex(unknownValue)) || Buffer.isBuffer(unknownValue)) {
            value = MichelsonBytes_1.MichelsonBytes.from(unknownValue);
        }
        else {
            throw new Error('MichelsonAddress: invalid value.');
        }
        return new MichelsonAddress(value, name);
    };
    MichelsonAddress.prototype.asRawValue = function () {
        var _a;
        var value = Buffer.isBuffer(this.address.value) ? this.address.value.toString('hex') : this.address.value;
        return this.name ? (_a = {}, _a[this.name] = value, _a) : value;
    };
    MichelsonAddress.prototype.toMichelineJSON = function () {
        return this.address.toMichelineJSON();
    };
    return MichelsonAddress;
}(MichelsonType_1.MichelsonType));
exports.MichelsonAddress = MichelsonAddress;
//# sourceMappingURL=MichelsonAddress.js.map