"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../../../../utils/error");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonBool = /** @class */ (function (_super) {
    __extends(MichelsonBool, _super);
    function MichelsonBool(value, name) {
        var _this = _super.call(this, name) || this;
        _this.value = value;
        return _this;
    }
    MichelsonBool.from = function (value, name) {
        return utils_1.isMichelinePrimitiveApplication(value)
            ? MichelsonBool.fromMicheline(value, name)
            : MichelsonBool.fromUnknown(value, name);
    };
    MichelsonBool.fromMicheline = function (micheline, name) {
        if (micheline.prim !== 'True' && micheline.prim !== 'False') {
            throw error_1.invalidArgumentTypeError('MichelsonBool', 'prim: True | False', "prim: " + micheline.prim);
        }
        return new MichelsonBool(micheline.prim === 'True', name);
    };
    MichelsonBool.fromUnknown = function (unknownValue, name) {
        if (unknownValue instanceof MichelsonBool) {
            return unknownValue;
        }
        if (typeof unknownValue !== 'boolean') {
            throw error_1.invalidArgumentTypeError('MichelsonBool', 'boolean', typeof unknownValue);
        }
        return new MichelsonBool(unknownValue, name);
    };
    MichelsonBool.prototype.asRawValue = function () {
        var _a;
        return this.name ? (_a = {}, _a[this.name] = this.value, _a) : this.value;
    };
    MichelsonBool.prototype.toMichelineJSON = function () {
        return {
            prim: this.value ? 'True' : 'False',
        };
    };
    return MichelsonBool;
}(MichelsonType_1.MichelsonType));
exports.MichelsonBool = MichelsonBool;
//# sourceMappingURL=MichelsonBool.js.map