/// <reference types="node" />
import { MichelineDataNode, MichelinePrimitive } from '../../micheline/MichelineNode';
import { MichelsonType } from '../MichelsonType';
export declare class MichelsonBytes extends MichelsonType {
    readonly value: Buffer;
    constructor(value: Buffer, name?: string);
    static from(value: unknown, name?: string): MichelsonBytes;
    static fromMicheline(micheline: MichelinePrimitive<'bytes'>, name?: string): MichelsonBytes;
    static fromUnknown(unknownValue: unknown, name?: string): MichelsonBytes;
    asRawValue(): Record<string, string> | string;
    toMichelineJSON(): MichelineDataNode;
}
