"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../../../../utils/error");
var hex_1 = require("../../../../../utils/hex");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonBytes = /** @class */ (function (_super) {
    __extends(MichelsonBytes, _super);
    function MichelsonBytes(value, name) {
        var _this = _super.call(this, name) || this;
        _this.value = value;
        return _this;
    }
    MichelsonBytes.from = function (value, name) {
        return utils_1.isMichelinePrimitive('bytes', value)
            ? MichelsonBytes.fromMicheline(value, name)
            : MichelsonBytes.fromUnknown(value, name);
    };
    MichelsonBytes.fromMicheline = function (micheline, name) {
        return MichelsonBytes.fromUnknown(micheline.bytes, name);
    };
    MichelsonBytes.fromUnknown = function (unknownValue, name) {
        if (unknownValue instanceof MichelsonBytes) {
            return unknownValue;
        }
        if (typeof unknownValue !== 'string' && !Buffer.isBuffer(unknownValue)) {
            throw error_1.invalidArgumentTypeError('MichelsonBytes', 'string or Buffer', typeof unknownValue + ": " + unknownValue);
        }
        return new MichelsonBytes(hex_1.hexToBytes(unknownValue), name);
    };
    MichelsonBytes.prototype.asRawValue = function () {
        var _a;
        return this.name ? (_a = {}, _a[this.name] = this.value.toString('hex'), _a) : this.value.toString('hex');
    };
    MichelsonBytes.prototype.toMichelineJSON = function () {
        return {
            bytes: this.value.toString('hex')
        };
    };
    return MichelsonBytes;
}(MichelsonType_1.MichelsonType));
exports.MichelsonBytes = MichelsonBytes;
//# sourceMappingURL=MichelsonBytes.js.map