"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var error_1 = require("../../../../../utils/error");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonInt = /** @class */ (function (_super) {
    __extends(MichelsonInt, _super);
    function MichelsonInt(value, name) {
        var _this = _super.call(this, name) || this;
        _this.value = value;
        return _this;
    }
    MichelsonInt.from = function (value, name) {
        return utils_1.isMichelinePrimitive('int', value)
            ? MichelsonInt.fromMicheline(value, name)
            : MichelsonInt.fromUnknown(value, name);
    };
    MichelsonInt.fromMicheline = function (micheline, name) {
        return MichelsonInt.fromUnknown(parseInt(micheline.int, 10), name);
    };
    MichelsonInt.fromUnknown = function (unknownValue, name) {
        if (unknownValue instanceof MichelsonInt) {
            return unknownValue;
        }
        if (typeof unknownValue !== 'number' && typeof unknownValue !== 'string' && !bignumber_1.default.isBigNumber(unknownValue)) {
            throw error_1.invalidArgumentTypeError('MichelsonInt', 'number or string or BigNumber', typeof unknownValue);
        }
        return new MichelsonInt(bignumber_1.default.isBigNumber(unknownValue) ? unknownValue : new bignumber_1.default(unknownValue), name);
    };
    MichelsonInt.prototype.asRawValue = function () {
        var _a;
        return this.name ? (_a = {}, _a[this.name] = this.value, _a) : this.value;
    };
    MichelsonInt.prototype.toMichelineJSON = function () {
        return {
            int: this.value.toString()
        };
    };
    return MichelsonInt;
}(MichelsonType_1.MichelsonType));
exports.MichelsonInt = MichelsonInt;
//# sourceMappingURL=MichelsonInt.js.map