"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../../../../utils/error");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonString = /** @class */ (function (_super) {
    __extends(MichelsonString, _super);
    function MichelsonString(value, name) {
        var _this = _super.call(this, name) || this;
        _this.value = value;
        return _this;
    }
    MichelsonString.from = function (value, name) {
        return utils_1.isMichelinePrimitive('string', value)
            ? MichelsonString.fromMicheline(value, name)
            : MichelsonString.fromUnknown(value, name);
    };
    MichelsonString.fromMicheline = function (micheline, name) {
        return MichelsonString.fromUnknown(micheline.string, name);
    };
    MichelsonString.fromUnknown = function (unknownValue, name) {
        if (unknownValue instanceof MichelsonString) {
            return unknownValue;
        }
        if (typeof unknownValue !== 'string') {
            throw error_1.invalidArgumentTypeError('MichelsonString', 'string', typeof unknownValue);
        }
        return new MichelsonString(unknownValue, name);
    };
    MichelsonString.prototype.asRawValue = function () {
        var _a;
        return this.name ? (_a = {}, _a[this.name] = this.value, _a) : this.value;
    };
    MichelsonString.prototype.toMichelineJSON = function () {
        return {
            string: this.value
        };
    };
    return MichelsonString;
}(MichelsonType_1.MichelsonType));
exports.MichelsonString = MichelsonString;
//# sourceMappingURL=MichelsonString.js.map