"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../../../../utils/error");
var utils_1 = require("../../utils");
var MichelsonType_1 = require("../MichelsonType");
var MichelsonUnit = /** @class */ (function (_super) {
    __extends(MichelsonUnit, _super);
    function MichelsonUnit() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MichelsonUnit.from = function (value, name) {
        if (value instanceof MichelsonUnit) {
            return value;
        }
        else if (utils_1.isMichelinePrimitiveApplication(value)) {
            return MichelsonUnit.fromMicheline(value, name);
        }
        else {
            return new MichelsonUnit();
        }
    };
    MichelsonUnit.fromMicheline = function (micheline, name) {
        if (micheline.prim !== 'Unit') {
            throw error_1.invalidArgumentTypeError('MichelsonUnit', 'prim: Unit', "prim: " + micheline.prim);
        }
        return new MichelsonUnit(name);
    };
    MichelsonUnit.prototype.asRawValue = function () {
        return undefined;
    };
    MichelsonUnit.prototype.toMichelineJSON = function () {
        return {
            prim: 'Unit'
        };
    };
    return MichelsonUnit;
}(MichelsonType_1.MichelsonType));
exports.MichelsonUnit = MichelsonUnit;
//# sourceMappingURL=MichelsonUnit.js.map