import { IACMessageDefinitionObject } from './message';
import { Payload } from './payloads/payload';
import { IACPayloadType } from './serializer';
export declare type IACProtocolVersion = number;
export declare type IACProtocolType = [IACProtocolVersion, IACPayloadType, Payload];
export declare class IACProtocol {
    readonly version: number;
    readonly payloadType: IACPayloadType;
    payload: Payload;
    constructor(data: Payload);
    decoded(): IACProtocolType;
    encoded(): string;
    static fromDecoded(data: IACMessageDefinitionObject[], chunkSize?: number): IACProtocol[];
    static fromEncoded(data: string[]): IACProtocol[];
}
