/// <reference types="node" />
import BigNumber from '../../../dependencies/src/bignumber.js-9.0.0/bignumber';
import { SerializedSyncProtocolSignedTransaction, SignedTransaction, SignedTransactionSerializer } from '../signed-transaction.serializer';
export declare type SerializedSignedBitcoinTransaction = [Buffer, Buffer];
export interface SignedBitcoinTransaction extends SignedTransaction {
    from: string[];
    amount: BigNumber;
    fee: BigNumber;
    accountIdentifier: string;
    transaction: string;
}
export declare class BitcoinSignedTransactionSerializer extends SignedTransactionSerializer {
    serialize(transaction: SignedBitcoinTransaction): SerializedSyncProtocolSignedTransaction;
    deserialize(serializedTx: SerializedSyncProtocolSignedTransaction): SignedBitcoinTransaction;
}
