"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_1 = require("../../../dependencies/src/bignumber.js-9.0.0/bignumber");
var signed_transaction_serializer_1 = require("../signed-transaction.serializer");
var toBuffer_1 = require("../utils/toBuffer");
var BitcoinSignedTransactionSerializer = /** @class */ (function (_super) {
    __extends(BitcoinSignedTransactionSerializer, _super);
    function BitcoinSignedTransactionSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BitcoinSignedTransactionSerializer.prototype.serialize = function (transaction) {
        var toSerialize = [];
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.ACCOUNT_IDENTIFIER] = transaction.accountIdentifier;
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.SIGNED_TRANSACTION] = transaction.transaction;
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.FROM] = transaction.from;
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.AMOUNT] = transaction.amount.toFixed();
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.FEE] = transaction.fee.toFixed();
        var serializedBuffer = toBuffer_1.toBuffer(toSerialize);
        return serializedBuffer;
    };
    BitcoinSignedTransactionSerializer.prototype.deserialize = function (serializedTx) {
        return {
            accountIdentifier: serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.ACCOUNT_IDENTIFIER].toString(),
            transaction: serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.SIGNED_TRANSACTION].toString(),
            from: serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.FROM].map(function (obj) { return obj.toString(); }),
            amount: new bignumber_1.default(serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.AMOUNT].toString()),
            fee: new bignumber_1.default(serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.FEE].toString())
        };
    };
    return BitcoinSignedTransactionSerializer;
}(signed_transaction_serializer_1.SignedTransactionSerializer));
exports.BitcoinSignedTransactionSerializer = BitcoinSignedTransactionSerializer;
//# sourceMappingURL=bitcoin-transactions.serializer.js.map