"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var signed_transaction_serializer_1 = require("../signed-transaction.serializer");
var toBuffer_1 = require("../utils/toBuffer");
var TezosSignedTransactionSerializer = /** @class */ (function (_super) {
    __extends(TezosSignedTransactionSerializer, _super);
    function TezosSignedTransactionSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TezosSignedTransactionSerializer.prototype.serialize = function (transaction) {
        var toSerialize = [];
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.SIGNED_TRANSACTION] = transaction.transaction;
        toSerialize[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.ACCOUNT_IDENTIFIER] = transaction.accountIdentifier;
        var serializedBuffer = toBuffer_1.toBuffer(toSerialize);
        return serializedBuffer;
    };
    TezosSignedTransactionSerializer.prototype.deserialize = function (serializedTx) {
        var signedTezosTx = {
            accountIdentifier: serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.ACCOUNT_IDENTIFIER].toString(),
            transaction: serializedTx[signed_transaction_serializer_1.SyncProtocolSignedTransactionKeys.SIGNED_TRANSACTION].toString()
        };
        return signedTezosTx;
    };
    return TezosSignedTransactionSerializer;
}(signed_transaction_serializer_1.SignedTransactionSerializer));
exports.TezosSignedTransactionSerializer = TezosSignedTransactionSerializer;
//# sourceMappingURL=tezos-transactions.serializer.js.map