"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var unsigned_transaction_serializer_1 = require("../unsigned-transaction.serializer");
var toBuffer_1 = require("../utils/toBuffer");
var AeternityUnsignedTransactionSerializer = /** @class */ (function (_super) {
    __extends(AeternityUnsignedTransactionSerializer, _super);
    function AeternityUnsignedTransactionSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AeternityUnsignedTransactionSerializer.prototype.serialize = function (transaction) {
        var serializedTx = toBuffer_1.toBuffer([
            [transaction.transaction.networkId, transaction.transaction.transaction],
            transaction.publicKey,
            transaction.callback ? transaction.callback : 'airgap-wallet://?d=' // callback-scheme
        ]);
        return serializedTx;
    };
    AeternityUnsignedTransactionSerializer.prototype.deserialize = function (serializedTx) {
        var unsignedAeternityTx = {
            publicKey: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.PUBLIC_KEY].toString(),
            transaction: {
                networkId: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.UNSIGNED_TRANSACTION][0].toString(),
                transaction: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.UNSIGNED_TRANSACTION][1].toString()
            },
            callback: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.CALLBACK].toString()
        };
        return unsignedAeternityTx;
    };
    return AeternityUnsignedTransactionSerializer;
}(unsigned_transaction_serializer_1.UnsignedTransactionSerializer));
exports.AeternityUnsignedTransactionSerializer = AeternityUnsignedTransactionSerializer;
//# sourceMappingURL=aeternity-transactions.serializer.js.map