/// <reference types="node" />
import BigNumber from '../../../dependencies/src/bignumber.js-9.0.0/bignumber';
import { SerializedSyncProtocolTransaction, UnsignedTransaction, UnsignedTransactionSerializer } from '../unsigned-transaction.serializer';
export declare type SerializedUnsignedBitcoinTransaction = [[[Buffer, Buffer, Buffer, Buffer, Buffer]], [[Buffer, Buffer, Buffer]]];
export interface IInTransaction {
    txId: string;
    value: BigNumber;
    vout: number;
    address: string;
    derivationPath?: string;
}
export interface IOutTransaction {
    recipient: string;
    isChange: boolean;
    value: BigNumber;
}
export interface RawBitcoinTransaction {
    ins: IInTransaction[];
    outs: IOutTransaction[];
}
export interface UnsignedBitcoinTransaction extends UnsignedTransaction {
    transaction: RawBitcoinTransaction;
}
export declare class BitcoinUnsignedTransactionSerializer extends UnsignedTransactionSerializer {
    serialize(unsignedTx: UnsignedBitcoinTransaction): SerializedSyncProtocolTransaction;
    deserialize(serializedTx: SerializedSyncProtocolTransaction): UnsignedBitcoinTransaction;
}
