/// <reference types="node" />
import { SerializedSyncProtocolTransaction, UnsignedTransaction, UnsignedTransactionSerializer } from '../unsigned-transaction.serializer';
export declare type SerializedUnsignedEthereumTransaction = [Buffer, Buffer, Buffer, Buffer, Buffer, Buffer, Buffer];
export interface RawEthereumTransaction {
    nonce: string;
    gasPrice: string;
    gasLimit: string;
    to: string;
    value: string;
    chainId: number;
    data: string;
}
export interface UnsignedEthereumTransaction extends UnsignedTransaction {
    transaction: RawEthereumTransaction;
}
export declare class EthereumUnsignedTransactionSerializer extends UnsignedTransactionSerializer {
    serialize(transaction: UnsignedEthereumTransaction): SerializedSyncProtocolTransaction;
    deserialize(serializedTx: SerializedSyncProtocolTransaction): UnsignedEthereumTransaction;
}
