"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var toBuffer_1 = require("../../utils/toBuffer");
var unsigned_transaction_serializer_1 = require("../unsigned-transaction.serializer");
var SubstrateUnsignedTransactionsSerializer = /** @class */ (function (_super) {
    __extends(SubstrateUnsignedTransactionsSerializer, _super);
    function SubstrateUnsignedTransactionsSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SubstrateUnsignedTransactionsSerializer.prototype.serialize = function (transaction) {
        var toSerialize = [];
        toSerialize[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.UNSIGNED_TRANSACTION] = [transaction.transaction.encoded];
        toSerialize[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.PUBLIC_KEY] = transaction.publicKey;
        toSerialize[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.CALLBACK] = transaction.callback ? transaction.callback : 'airgap-wallet://?d=';
        return toBuffer_1.toBuffer(toSerialize);
    };
    SubstrateUnsignedTransactionsSerializer.prototype.deserialize = function (serializedTx) {
        var unsignedTx = serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.UNSIGNED_TRANSACTION];
        return {
            transaction: {
                encoded: unsignedTx.toString()
            },
            publicKey: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.PUBLIC_KEY].toString(),
            callback: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.CALLBACK].toString()
        };
    };
    return SubstrateUnsignedTransactionsSerializer;
}(unsigned_transaction_serializer_1.UnsignedTransactionSerializer));
exports.SubstrateUnsignedTransactionsSerializer = SubstrateUnsignedTransactionsSerializer;
//# sourceMappingURL=substrate-transactions.serializer.js.map