"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var unsigned_transaction_serializer_1 = require("../unsigned-transaction.serializer");
var toBuffer_1 = require("../utils/toBuffer");
var TezosUnsignedTransactionSerializer = /** @class */ (function (_super) {
    __extends(TezosUnsignedTransactionSerializer, _super);
    function TezosUnsignedTransactionSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TezosUnsignedTransactionSerializer.prototype.serialize = function (unsignedTx) {
        var toSerialize = [
            [unsignedTx.transaction.binaryTransaction],
            unsignedTx.publicKey,
            unsignedTx.callback ? unsignedTx.callback : 'airgap-wallet://?d=' // callback-scheme
        ];
        var serializedTx = toBuffer_1.toBuffer(toSerialize);
        return serializedTx;
    };
    TezosUnsignedTransactionSerializer.prototype.deserialize = function (serializedTx) {
        var tezosTx = serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.UNSIGNED_TRANSACTION];
        var binaryTx = tezosTx[0];
        return {
            transaction: {
                binaryTransaction: binaryTx.toString()
            },
            publicKey: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.PUBLIC_KEY].toString(),
            callback: serializedTx[unsigned_transaction_serializer_1.SyncProtocolUnsignedTransactionKeys.CALLBACK].toString()
        };
    };
    return TezosUnsignedTransactionSerializer;
}(unsigned_transaction_serializer_1.UnsignedTransactionSerializer));
exports.TezosUnsignedTransactionSerializer = TezosUnsignedTransactionSerializer;
//# sourceMappingURL=tezos-transactions.serializer.js.map