"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var toBuffer_1 = require("./utils/toBuffer");
var SyncProtocolWalletSync;
(function (SyncProtocolWalletSync) {
    SyncProtocolWalletSync[SyncProtocolWalletSync["PUBLIC_KEY"] = 0] = "PUBLIC_KEY";
    SyncProtocolWalletSync[SyncProtocolWalletSync["DERIVATION_PATH"] = 1] = "DERIVATION_PATH";
    SyncProtocolWalletSync[SyncProtocolWalletSync["IS_EXTENDED_PUBLIC_KEY"] = 2] = "IS_EXTENDED_PUBLIC_KEY";
})(SyncProtocolWalletSync = exports.SyncProtocolWalletSync || (exports.SyncProtocolWalletSync = {}));
var WalletSerializer = /** @class */ (function () {
    function WalletSerializer() {
    }
    WalletSerializer.prototype.serialize = function (syncWalletRequest) {
        var toSerialize = [];
        toSerialize[SyncProtocolWalletSync.PUBLIC_KEY] = syncWalletRequest.publicKey;
        toSerialize[SyncProtocolWalletSync.DERIVATION_PATH] = syncWalletRequest.derivationPath;
        toSerialize[SyncProtocolWalletSync.IS_EXTENDED_PUBLIC_KEY] = syncWalletRequest.isExtendedPublicKey;
        var serializedBuffer = toBuffer_1.toBuffer(toSerialize);
        return serializedBuffer;
    };
    WalletSerializer.prototype.deserialize = function (serializedWalletRequest) {
        var syncWalletRequest = {
            publicKey: serializedWalletRequest[SyncProtocolWalletSync.PUBLIC_KEY].toString(),
            derivationPath: serializedWalletRequest[SyncProtocolWalletSync.DERIVATION_PATH].toString(),
            isExtendedPublicKey: serializedWalletRequest[SyncProtocolWalletSync.IS_EXTENDED_PUBLIC_KEY].toString() === '0' ? false : true
        };
        return syncWalletRequest;
    };
    return WalletSerializer;
}());
exports.WalletSerializer = WalletSerializer;
//# sourceMappingURL=wallet-sync.serializer.js.map