import { ProtocolBlockExplorer } from './ProtocolBlockExplorer';
export declare enum NetworkType {
    MAINNET = "MAINNET",
    TESTNET = "TESTNET",
    CUSTOM = "CUSTOM"
}
export declare abstract class ProtocolNetwork<T = unknown> {
    readonly name: string;
    readonly type: NetworkType;
    readonly rpcUrl: string;
    readonly blockExplorer: ProtocolBlockExplorer;
    readonly extras: T;
    get identifier(): string;
    constructor(name: string, type: NetworkType, rpcUrl: string, blockExplorer: ProtocolBlockExplorer, extras: T);
}
