"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var AirGapWallet = /** @class */ (function () {
    function AirGapWallet(protocol, publicKey, isExtendedPublicKey, derivationPath, addressIndex) {
        this.protocol = protocol;
        this.publicKey = publicKey;
        this.isExtendedPublicKey = isExtendedPublicKey;
        this.derivationPath = derivationPath;
        this.addressIndex = addressIndex;
        this.addresses = []; // used for cache
    }
    Object.defineProperty(AirGapWallet.prototype, "receivingPublicAddress", {
        get: function () {
            return this.addresses[this.addressIndex !== undefined ? this.addressIndex : 0];
        },
        enumerable: true,
        configurable: true
    });
    AirGapWallet.prototype.setProtocol = function (protocol) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.protocol.identifier !== protocol.identifier) {
                    throw new Error('Can only set same protocol with a different network');
                }
                this.protocol = protocol;
                return [2 /*return*/];
            });
        });
    };
    AirGapWallet.prototype.deriveAddresses = function (amount) {
        if (amount === void 0) { amount = 50; }
        return __awaiter(this, void 0, void 0, function () {
            var parts, offset, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!this.isExtendedPublicKey) return [3 /*break*/, 3];
                        parts = this.derivationPath.split('/');
                        offset = 0;
                        if (!parts[parts.length - 1].endsWith("'")) {
                            offset = Number.parseInt(parts[parts.length - 1], 10);
                        }
                        return [4 /*yield*/, this.protocol.getAddressesFromExtendedPublicKey(this.publicKey, 0, amount, offset)];
                    case 1:
                        _a = [(_b.sent())];
                        return [4 /*yield*/, this.protocol.getAddressesFromExtendedPublicKey(this.publicKey, 1, amount, offset)];
                    case 2: return [2 /*return*/, __spreadArrays.apply(void 0, _a.concat([(_b.sent())]))];
                    case 3: return [2 /*return*/, this.protocol.getAddressesFromPublicKey(this.publicKey)];
                }
            });
        });
    };
    AirGapWallet.prototype.toJSON = function () {
        return {
            protocolIdentifier: this.protocol.identifier,
            networkIdentifier: this.protocol.options.network.identifier,
            publicKey: this.publicKey,
            isExtendedPublicKey: this.isExtendedPublicKey,
            derivationPath: this.derivationPath,
            addresses: this.addresses,
            addressIndex: this.addressIndex
        };
    };
    return AirGapWallet;
}());
exports.AirGapWallet = AirGapWallet;
//# sourceMappingURL=AirGapWallet.js.map