/// <reference types="node" />
import { RLPData } from '../utils/toBuffer';
import { Payload } from './payload';
interface DecodedChunkedPayload {
    currentPage: number;
    total: number;
    payload: Buffer;
}
export declare class ChunkedPayload implements Payload {
    currentPage: number;
    total: number;
    buffer: Buffer;
    constructor(currentPage: number, total: number, buffer: Buffer);
    static fromDecoded(object: DecodedChunkedPayload): ChunkedPayload;
    static fromEncoded(buf: [Buffer, Buffer, Buffer]): ChunkedPayload;
    asArray(): RLPData;
}
export {};
